Makefile 75.8 KB
Newer Older
1
# SPDX-License-Identifier: GPL-2.0+
2

T
Tom Rini 已提交
3
VERSION = 2021
T
Tom Rini 已提交
4
PATCHLEVEL = 10
W
Wolfgang Denk 已提交
5
SUBLEVEL =
T
Tom Rini 已提交
6
EXTRAVERSION =
7
NAME =
8

9 10 11 12 13 14
# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

15 16 17
# Do not use make's built-in rules and variables
# (this increases performance and avoids hard-to-debug behaviour)
MAKEFLAGS += -rR
18

19
# Determine target architecture for the sandbox
20
include include/host_arch.h
21 22 23 24 25
ifeq ("", "$(CROSS_COMPILE)")
  MK_ARCH="${shell uname -m}"
else
  MK_ARCH="${shell echo $(CROSS_COMPILE) | sed -n 's/^\s*\([^\/]*\/\)*\([^-]*\)-\S*/\2/p'}"
endif
26 27 28 29 30 31 32
unexport HOST_ARCH
ifeq ("x86_64", $(MK_ARCH))
  export HOST_ARCH=$(HOST_ARCH_X86_64)
else ifneq (,$(findstring $(MK_ARCH), "i386" "i486" "i586" "i686"))
  export HOST_ARCH=$(HOST_ARCH_X86)
else ifneq (,$(findstring $(MK_ARCH), "aarch64" "armv8l"))
  export HOST_ARCH=$(HOST_ARCH_AARCH64)
33
else ifneq (,$(findstring $(MK_ARCH), "arm" "armv7" "armv7l"))
34 35 36 37 38 39 40 41
  export HOST_ARCH=$(HOST_ARCH_ARM)
else ifeq ("riscv32", $(MK_ARCH))
  export HOST_ARCH=$(HOST_ARCH_RISCV32)
else ifeq ("riscv64", $(MK_ARCH))
  export HOST_ARCH=$(HOST_ARCH_RISCV64)
endif
undefine MK_ARCH

42 43 44 45 46 47
# Avoid funny character set dependencies
unexport LC_ALL
LC_COLLATE=C
LC_NUMERIC=C
export LC_COLLATE LC_NUMERIC

48 49 50
# Avoid interference with shell env settings
unexport GREP_OPTIONS

51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66
# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.o targets which finally
# turn into vmlinux), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89
# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing will be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.
#
90 91 92 93 94 95 96 97 98 99
# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
  KBUILD_VERBOSE = $(V)
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

100 101 102 103 104 105 106
ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif
107

108 109 110 111 112 113
# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(filter 4.%,$(MAKE_VERSION)),)	# make-4
ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
  quiet=silent_
114
endif
115 116 117
else					# make-3.8x
ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
  quiet=silent_
118 119 120
endif
endif

121
export quiet Q KBUILD_VERBOSE
122

123 124 125 126 127
# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
128
#
129 130 131 132 133
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
134
#
135 136 137 138 139 140
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.

# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)
141

142 143
# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
144
ifeq ("$(origin O)", "command line")
145 146 147 148 149 150 151 152 153 154 155 156 157 158
  KBUILD_OUTPUT := $(O)
endif

# That's our default target when none is given on the command line
PHONY := _all
_all:

# Cancel implicit rules on top Makefile
$(CURDIR)/Makefile Makefile: ;

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
159 160
KBUILD_OUTPUT := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) \
								&& /bin/pwd)
161
$(if $(KBUILD_OUTPUT),, \
162
     $(error failed to create output directory "$(saved-output)"))
163

164 165 166 167 168 169 170
# Look for make include files relative to root of kernel src
#
# This does not become effective immediately because MAKEFLAGS is re-parsed
# once after the Makefile is read.  It is OK since we are going to invoke
# 'sub-make' below.
MAKEFLAGS += --include-dir=$(CURDIR)

171 172 173 174 175 176
PHONY += $(MAKECMDGOALS) sub-make

$(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
	@:

sub-make: FORCE
177 178
	$(Q)$(MAKE) -C $(KBUILD_OUTPUT) KBUILD_SRC=$(CURDIR) \
	-f $(CURDIR)/Makefile $(filter-out _all sub-make,$(MAKECMDGOALS))
179 180 181 182 183 184 185 186 187

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

188 189 190 191 192 193 194 195 196 197 198 199
# Do not print "Entering directory ...",
# but we want to display it when entering to the output directory
# so that IDEs/editors are able to understand relative filenames.
MAKEFLAGS += --no-print-directory

# Call a source code checker (by default, "sparse") as part of the
# C compilation.
#
# Use 'make C=1' to enable checking of only re-compiled files.
# Use 'make C=2' to enable checking of *all* source files, regardless
# of whether they are re-compiled or not.
#
200
# See the file "doc/sparse.txt" for more details, including
201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220
# where to get the "sparse" utility.

ifeq ("$(origin C)", "command line")
  KBUILD_CHECKSRC = $(C)
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif

ifeq ("$(origin M)", "command line")
  KBUILD_EXTMOD := $(M)
endif

221 222
# If building an external module we do not care about the all: rule
# but instead _all depend on modules
223
PHONY += all
224
ifeq ($(KBUILD_EXTMOD),)
225
_all: all
226
else
227
_all: modules
228
endif
229

230 231 232 233 234 235 236 237 238 239 240 241
ifeq ($(KBUILD_SRC),)
        # building in the source tree
        srctree := .
else
        ifeq ($(KBUILD_SRC)/,$(dir $(CURDIR)))
                # building in a subdirectory of the source tree
                srctree := ..
        else
                srctree := $(KBUILD_SRC)
        endif
endif
objtree		:= .
242 243 244 245 246 247 248
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))

export srctree objtree VPATH

W
Wolfgang Denk 已提交
249 250 251
# Make sure CDPATH settings don't interfere
unexport CDPATH

W
wdenk 已提交
252 253 254
#########################################################################

HOSTARCH := $(shell uname -m | \
G
Graeme Russ 已提交
255
	sed -e s/i.86/x86/ \
W
wdenk 已提交
256 257 258
	    -e s/sun4u/sparc64/ \
	    -e s/arm.*/arm/ \
	    -e s/sa110/arm/ \
K
Kumar Gala 已提交
259 260
	    -e s/ppc64/powerpc/ \
	    -e s/ppc/powerpc/ \
N
Nobuhiro Iwamatsu 已提交
261 262
	    -e s/macppc/powerpc/\
	    -e s/sh.*/sh/)
W
wdenk 已提交
263

264
HOSTOS := $(shell uname -s | tr '[:upper:]' '[:lower:]' | \
W
wdenk 已提交
265 266
	    sed -e 's/\(cygwin\).*/cygwin/')

267
export	HOSTARCH HOSTOS
W
wdenk 已提交
268

269
#########################################################################
270

271
# set default to nothing for native builds
W
Wolfgang Denk 已提交
272
ifeq ($(HOSTARCH),$(ARCH))
273
CROSS_COMPILE ?=
274 275
endif

M
Masahiro Yamada 已提交
276 277 278
KCONFIG_CONFIG	?= .config
export KCONFIG_CONFIG

279 280 281 282 283
# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

284 285 286 287
HOST_LFS_CFLAGS := $(shell getconf LFS_CFLAGS 2>/dev/null)
HOST_LFS_LDFLAGS := $(shell getconf LFS_LDFLAGS 2>/dev/null)
HOST_LFS_LIBS := $(shell getconf LFS_LIBS 2>/dev/null)

288 289
HOSTCC       = cc
HOSTCXX      = c++
290
KBUILD_HOSTCFLAGS   := -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer \
291
		$(HOST_LFS_CFLAGS) $(HOSTCFLAGS)
292 293 294
KBUILD_HOSTCXXFLAGS := -O2 $(HOST_LFS_CFLAGS) $(HOSTCXXFLAGS)
KBUILD_HOSTLDFLAGS  := $(HOST_LFS_LDFLAGS) $(HOSTLDFLAGS)
KBUILD_HOSTLDLIBS   := $(HOST_LFS_LIBS) $(HOSTLDLIBS)
295

296 297 298 299 300
# With the move to GCC 6, we have implicitly upgraded our language
# standard to GNU11 (see https://gcc.gnu.org/gcc-5/porting_to.html).
# Some Linux distributions (including RHEL7, SLES13, Debian 8) still
# have older compilers as their default, so we make it explicit for
# these that our host tools are GNU11 (i.e. C11 w/ GNU extensions).
301
CSTD_FLAG := -std=gnu11
302
KBUILD_HOSTCFLAGS += $(CSTD_FLAG)
303

304
ifeq ($(HOSTOS),cygwin)
305
KBUILD_HOSTCFLAGS	+= -ansi
306 307 308 309 310 311 312 313
endif

# Mac OS X / Darwin's C preprocessor is Apple specific.  It
# generates numerous errors and warnings.  We want to bypass it
# and use GNU C's cpp.	To do this we pass the -traditional-cpp
# option to the compiler.  Note that the -traditional-cpp flag
# DOES NOT have the same semantics as GNU C's flag, all it does
# is invoke the GNU preprocessor in stock ANSI/ISO C fashion.
314
#
315 316 317
# Apple's linker is similar, thanks to the new 2 stage linking
# multiple symbol definitions are treated as errors, hence the
# -multiply_defined suppress option to turn off this error.
318
#
319 320 321 322 323 324 325 326
ifeq ($(HOSTOS),darwin)
# get major and minor product version (e.g. '10' and '6' for Snow Leopard)
DARWIN_MAJOR_VERSION	= $(shell sw_vers -productVersion | cut -f 1 -d '.')
DARWIN_MINOR_VERSION	= $(shell sw_vers -productVersion | cut -f 2 -d '.')

os_x_before	= $(shell if [ $(DARWIN_MAJOR_VERSION) -le $(1) -a \
	$(DARWIN_MINOR_VERSION) -le $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)

認小默's avatar
認小默 已提交
327
os_x_after = $(shell if [ $(DARWIN_MAJOR_VERSION) -ge $(1) -a \
328
	$(DARWIN_MINOR_VERSION) -ge $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
認小默's avatar
認小默 已提交
329

330 331
# Snow Leopards build environment has no longer restrictions as described above
HOSTCC       = $(call os_x_before, 10, 5, "cc", "gcc")
332 333
KBUILD_HOSTCFLAGS  += $(call os_x_before, 10, 4, "-traditional-cpp")
KBUILD_HOSTLDFLAGS += $(call os_x_before, 10, 5, "-multiply_defined suppress")
334

335
# macOS Mojave (10.14.X)
認小默's avatar
認小默 已提交
336
# Undefined symbols for architecture x86_64: "_PyArg_ParseTuple"
337
KBUILD_HOSTLDFLAGS += $(call os_x_after, 10, 14, "-lpython -dynamclib", "")
338 339
endif

340 341 342 343 344 345
# Decide whether to build built-in, modular, or both.
# Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

346 347 348 349
# If we have only "make modules", don't compile built-in objects.
# When we're building modules with modversions, we need to consider
# the built-in objects during the descend as well, in order to
# make sure the checksums are up to date before we record them.
350 351 352 353 354

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

355 356 357
# If we have "make <whatever> modules", compile modules
# in addition to whatever we do anyway.
# Just "make" or "make all" shall build modules as well
358 359 360 361 362 363 364 365 366 367

# U-Boot does not need modules
#ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
#  KBUILD_MODULES := 1
#endif

#ifeq ($(MAKECMDGOALS),)
#  KBUILD_MODULES := 1
#endif

368 369 370 371
# Check ths size of a binary:
# Args:
#   $1: File to check
#   #2: Size limit in bytes (decimal or 0xhex)
372 373 374 375 376
define size_check
	actual=$$( wc -c $1 | awk '{print $$1}'); \
	limit=$$( printf "%d" $2 ); \
	if test $$actual -gt $$limit; then \
		echo "$1 exceeds file size limit:" >&2; \
377
		echo "  limit:  $$(printf %#x $$limit) bytes" >&2; \
378 379
		echo "  actual: $$(printf %#x $$actual) bytes" >&2; \
		echo "  excess: $$(printf %#x $$((actual - limit))) bytes" >&2;\
380 381 382 383 384
		exit 1; \
	fi
endef
export size_check

385 386 387
export KBUILD_MODULES KBUILD_BUILTIN
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

M
Masahiro Yamada 已提交
388
# We need some generic definitions (do not try to remake the file).
389 390
scripts/Kbuild.include: ;
include scripts/Kbuild.include
391

392
# Make variables (CC, etc...)
W
wdenk 已提交
393

394 395 396 397
AS		= $(CROSS_COMPILE)as
# Always use GNU ld
ifneq ($(shell $(CROSS_COMPILE)ld.bfd -v 2> /dev/null),)
LD		= $(CROSS_COMPILE)ld.bfd
398
else
399 400 401 402 403 404 405 406 407 408
LD		= $(CROSS_COMPILE)ld
endif
CC		= $(CROSS_COMPILE)gcc
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
LDR		= $(CROSS_COMPILE)ldr
STRIP		= $(CROSS_COMPILE)strip
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
409 410
LEX		= flex
YACC		= bison
411
AWK		= awk
412
PERL		= perl
S
Stefano Babic 已提交
413
PYTHON		?= python
414
PYTHON2		= python2
415
PYTHON3		?= python3
S
Simon Glass 已提交
416 417 418 419 420 421 422

# The devicetree compiler and pylibfdt are automatically built unless DTC is
# provided. If DTC is provided, it is assumed the pylibfdt is available too.
DTC_INTREE	:= $(objtree)/scripts/dtc/dtc
DTC		?= $(DTC_INTREE)
DTC_MIN_VERSION	:= 010406

423 424 425 426 427
CHECK		= sparse

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
		  -Wbitwise -Wno-return-void -D__CHECK_ENDIAN__ $(CF)

428
KBUILD_CPPFLAGS := -D__KERNEL__ -D__UBOOT__
429 430 431

KBUILD_CFLAGS   := -Wall -Wstrict-prototypes \
		   -Wno-format-security \
432
		   -fno-builtin -ffreestanding $(CSTD_FLAG)
433
KBUILD_CFLAGS	+= -fshort-wchar -fno-strict-aliasing
434
KBUILD_AFLAGS   := -D__ASSEMBLY__
435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451
KBUILD_LDFLAGS  :=

ifeq ($(cc-name),clang)
ifneq ($(CROSS_COMPILE),)
CLANG_TARGET	:= --target=$(notdir $(CROSS_COMPILE:%-=%))
GCC_TOOLCHAIN_DIR := $(dir $(shell which $(LD)))
CLANG_PREFIX	:= --prefix=$(GCC_TOOLCHAIN_DIR)
GCC_TOOLCHAIN	:= $(realpath $(GCC_TOOLCHAIN_DIR)/..)
endif
ifneq ($(GCC_TOOLCHAIN),)
CLANG_GCC_TC	:= --gcc-toolchain=$(GCC_TOOLCHAIN)
endif
KBUILD_CFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
KBUILD_AFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
KBUILD_CFLAGS += $(call cc-option, -no-integrated-as)
KBUILD_AFLAGS += $(call cc-option, -no-integrated-as)
endif
452

453 454 455 456
# Don't generate position independent code
KBUILD_CFLAGS	+= $(call cc-option,-fno-PIE)
KBUILD_AFLAGS	+= $(call cc-option,-fno-PIE)

457 458 459
# Read UBOOTRELEASE from include/config/uboot.release (if it exists)
UBOOTRELEASE = $(shell cat include/config/uboot.release 2> /dev/null)
UBOOTVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
460

461
export VERSION PATCHLEVEL SUBLEVEL UBOOTRELEASE UBOOTVERSION
M
Masahiro Yamada 已提交
462
export ARCH CPU BOARD VENDOR SOC CPUDIR BOARDDIR
463 464
export CONFIG_SHELL HOSTCC KBUILD_HOSTCFLAGS CROSS_COMPILE AS LD CC
export CPP AR NM LDR STRIP OBJCOPY OBJDUMP KBUILD_HOSTLDFLAGS KBUILD_HOSTLDLIBS
465
export MAKE LEX YACC AWK PERL PYTHON PYTHON2 PYTHON3
466
export HOSTCXX KBUILD_HOSTCXXFLAGS CHECK CHECKFLAGS DTC DTC_FLAGS
467

468
export KBUILD_CPPFLAGS NOSTDINC_FLAGS UBOOTINCLUDE OBJCOPYFLAGS KBUILD_LDFLAGS
469 470
export KBUILD_CFLAGS KBUILD_AFLAGS

471 472
export CC_VERSION_TEXT := $(shell $(CC) --version | head -n 1)

473 474 475 476 477 478 479
# When compiling out-of-tree modules, put MODVERDIR in the module
# tree rather than in the kernel tree. The kernel tree might
# even be read-only.
export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions

# Files to ignore in find ... statements

480 481 482
export RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o    \
			  -name CVS -o -name .pc -o -name .hg -o -name .git \) \
			  -prune -o
483 484 485 486 487 488 489 490 491 492 493 494 495 496 497
export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn \
			 --exclude CVS --exclude .pc --exclude .hg --exclude .git

# ===========================================================================
# Rules shared between *config targets and build targets

# Basic helpers built in scripts/
PHONY += scripts_basic
scripts_basic:
	$(Q)$(MAKE) $(build)=scripts/basic
	$(Q)rm -f .tmp_quiet_recordmcount

# To avoid any implicit rule to kick in, define an empty command.
scripts/basic/%: scripts_basic ;

498 499 500 501 502 503 504
PHONY += outputmakefile
# outputmakefile generates a Makefile in the output directory, if using a
# separate output directory. This allows convenient use of make in the
# output directory.
outputmakefile:
ifneq ($(KBUILD_SRC),)
	$(Q)ln -fsn $(srctree) source
505
	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/mkmakefile $(srctree)
506
endif
507

508 509 510 511 512 513 514 515
# To make sure we do not include .config for any of the *config targets
# catch them early, and hand them over to scripts/kconfig/Makefile
# It is allowed to specify more targets when calling make, including
# mixing *config targets and build targets.
# For example 'make oldconfig all'.
# Detect when mixed targets is specified, and make a second invocation
# of make so .config is not included in this case either (for *config).

516 517
version_h := include/generated/version_autogenerated.h
timestamp_h := include/generated/timestamp_autogenerated.h
518
defaultenv_h := include/generated/defaultenv_autogenerated.h
519
dt_h := include/generated/dt.h
520

521
no-dot-config-targets := clean clobber mrproper distclean \
522
			 help %docs check% coccicheck \
523
			 ubootversion backup tests check qcheck tcheck
524 525 526 527 528 529 530 531 532 533

config-targets := 0
mixed-targets  := 0
dot-config     := 1

ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
	ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
		dot-config := 0
	endif
endif
W
Wolfgang Denk 已提交
534

535 536 537
ifeq ($(KBUILD_EXTMOD),)
        ifneq ($(filter config %config,$(MAKECMDGOALS)),)
                config-targets := 1
M
Masahiro Yamada 已提交
538
                ifneq ($(words $(MAKECMDGOALS)),1)
539 540 541
                        mixed-targets := 1
                endif
        endif
542
endif
W
wdenk 已提交
543

544 545 546 547
ifeq ($(mixed-targets),1)
# ===========================================================================
# We're called with mixed targets (*config and build targets).
# Handle them one by one.
548

549
PHONY += $(MAKECMDGOALS) __build_one_by_one
550

551
$(filter-out __build_one_by_one, $(MAKECMDGOALS)): __build_one_by_one
552 553
	@:

554
__build_one_by_one:
555 556 557 558
	$(Q)set -e; \
	for i in $(MAKECMDGOALS); do \
		$(MAKE) -f $(srctree)/Makefile $$i; \
	done
559

560 561 562 563 564
else
ifeq ($(config-targets),1)
# ===========================================================================
# *config targets only - make sure prerequisites are updated, and descend
# in scripts/kconfig to make the *config target
W
wdenk 已提交
565

M
Masahiro Yamada 已提交
566 567
KBUILD_DEFCONFIG := sandbox_defconfig
export KBUILD_DEFCONFIG KBUILD_KCONFIG
568

M
Masahiro Yamada 已提交
569
config: scripts_basic outputmakefile FORCE
570
	$(Q)$(MAKE) $(build)=scripts/kconfig $@
M
Masahiro Yamada 已提交
571 572

%config: scripts_basic outputmakefile FORCE
573
	$(Q)$(MAKE) $(build)=scripts/kconfig $@
574

575 576 577 578
else
# ===========================================================================
# Build targets only - this includes vmlinux, arch specific targets, clean
# targets and others. In general all targets except *config targets.
579

580 581 582 583
# Additional helpers built in scripts/
# Carefully list dependencies so we do not try to build scripts twice
# in parallel
PHONY += scripts
584
scripts: scripts_basic scripts_dtc include/config/auto.conf
585 586
	$(Q)$(MAKE) $(build)=$(@)

587 588
ifeq ($(dot-config),1)
# Read in config
M
Masahiro Yamada 已提交
589 590 591 592 593 594 595 596 597 598 599 600 601 602
-include include/config/auto.conf

# Read in dependencies to all Kconfig* files, make sure to run
# oldconfig if changes are detected.
-include include/config/auto.conf.cmd

# To avoid any implicit rule to kick in, define an empty command
$(KCONFIG_CONFIG) include/config/auto.conf.cmd: ;

# If .config is newer than include/config/auto.conf, someone tinkered
# with it and forgot to run make oldconfig.
# if auto.conf.cmd is missing then we are probably in a cleaned tree so
# we execute the config step to be sure to catch updated Kconfig files
include/config/%.conf: $(KCONFIG_CONFIG) include/config/auto.conf.cmd
603
	$(Q)$(MAKE) -f $(srctree)/Makefile syncconfig
604 605 606 607 608 609 610 611 612
	@# If the following part fails, include/config/auto.conf should be
	@# deleted so "make silentoldconfig" will be re-run on the next build.
	$(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf || \
		{ rm -f include/config/auto.conf; false; }
	@# include/config.h has been updated after "make silentoldconfig".
	@# We need to touch include/config/auto.conf so it gets newer
	@# than include/config.h.
	@# Otherwise, 'make silentoldconfig' would be invoked twice.
	$(Q)touch include/config/auto.conf
M
Masahiro Yamada 已提交
613

614
u-boot.cfg spl/u-boot.cfg tpl/u-boot.cfg:
615 616
	$(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf $(@)

617 618
-include include/autoconf.mk
-include include/autoconf.mk.dep
W
wdenk 已提交
619

M
Masahiro Yamada 已提交
620 621 622 623
# We want to include arch/$(ARCH)/config.mk only when include/config/auto.conf
# is up-to-date. When we switch to a different board configuration, old CONFIG
# macros are still remaining in include/config/auto.conf. Without the following
# gimmick, wrong config.mk would be included leading nasty warnings/errors.
624 625 626 627 628
ifneq ($(wildcard $(KCONFIG_CONFIG)),)
ifneq ($(wildcard include/config/auto.conf),)
autoconf_is_old := $(shell find . -path ./$(KCONFIG_CONFIG) -newer \
						include/config/auto.conf)
ifeq ($(autoconf_is_old),)
629 630
include config.mk
include arch/$(ARCH)/Makefile
631
endif
632 633
endif
endif
634

635 636 637 638 639 640 641 642 643
# These are set by the arch-specific config.mk. Make sure they are exported
# so they can be used when building an EFI application.
export EFI_LDS		# Filename of EFI link script in arch/$(ARCH)/lib
export EFI_CRT0		# Filename of EFI CRT0 in arch/$(ARCH)/lib
export EFI_RELOC	# Filename of EFU relocation code in arch/$(ARCH)/lib
export CFLAGS_EFI	# Compiler flags to add when building EFI app
export CFLAGS_NON_EFI	# Compiler flags to remove when building EFI app
export EFI_TARGET	# binutils target if EFI is natively supported

644 645 646 647 648
# If board code explicitly specified LDSCRIPT or CONFIG_SYS_LDSCRIPT, use
# that (or fail if absent).  Otherwise, search for a linker script in a
# standard location.

ifndef LDSCRIPT
649
	#LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds.debug
650 651
	ifdef CONFIG_SYS_LDSCRIPT
		# need to strip off double quotes
652
		LDSCRIPT := $(srctree)/$(CONFIG_SYS_LDSCRIPT:"%"=%)
653 654 655
	endif
endif

656
# If there is no specified link script, we look in a number of places for it
657 658
ifndef LDSCRIPT
	ifeq ($(wildcard $(LDSCRIPT)),)
659
		LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds
660 661
	endif
	ifeq ($(wildcard $(LDSCRIPT)),)
662
		LDSCRIPT := $(srctree)/$(CPUDIR)/u-boot.lds
663
	endif
664
	ifeq ($(wildcard $(LDSCRIPT)),)
665
		LDSCRIPT := $(srctree)/arch/$(ARCH)/cpu/u-boot.lds
666
	endif
667 668
endif

669
else
M
Masahiro Yamada 已提交
670 671
# Dummy target needed, because used as prerequisite
include/config/auto.conf: ;
672 673
endif # $(dot-config)

674 675 676 677 678 679 680 681
#
# Xtensa linker script cannot be preprocessed with -ansi because of
# preprocessor operations on strings that don't make C identifiers.
#
ifeq ($(CONFIG_XTENSA),)
LDPPFLAGS	+= -ansi
endif

682 683 684 685 686
ifdef CONFIG_CC_OPTIMIZE_FOR_SIZE
KBUILD_CFLAGS	+= -Os
else
KBUILD_CFLAGS	+= -O2
endif
687

688 689 690 691 692 693 694 695 696 697 698 699 700 701 702 703 704 705 706 707 708 709 710 711 712
LTO_CFLAGS :=
LTO_FINAL_LDFLAGS :=
export LTO_CFLAGS LTO_FINAL_LDFLAGS
ifdef CONFIG_LTO
	ifeq ($(cc-name),clang)
		LTO_CFLAGS		+= -flto
		LTO_FINAL_LDFLAGS	+= -flto

		AR			= $(shell $(CC) -print-prog-name=llvm-ar)
		NM			= $(shell $(CC) -print-prog-name=llvm-nm)
	else
		NPROC			:= $(shell nproc 2>/dev/null || echo 1)
		LTO_CFLAGS		+= -flto=$(NPROC)
		LTO_FINAL_LDFLAGS	+= -fuse-linker-plugin -flto=$(NPROC)

		# use plugin aware tools
		AR			= $(CROSS_COMPILE)gcc-ar
		NM			= $(CROSS_COMPILE)gcc-nm
	endif

	CFLAGS_NON_EFI			+= $(LTO_CFLAGS)

	KBUILD_CFLAGS			+= $(LTO_CFLAGS)
endif

J
Joel Peshkin 已提交
713 714 715 716
ifeq ($(CONFIG_STACKPROTECTOR),y)
KBUILD_CFLAGS += $(call cc-option,-fstack-protector-strong)
CFLAGS_EFI += $(call cc-option,-fno-stack-protector)
else
717
KBUILD_CFLAGS += $(call cc-option,-fno-stack-protector)
J
Joel Peshkin 已提交
718
endif
719
KBUILD_CFLAGS += $(call cc-option,-fno-delete-null-pointer-checks)
720

721 722 723
# disable pointer signed / unsigned warnings in gcc 4.0
KBUILD_CFLAGS += -Wno-pointer-sign

724 725 726
# disable stringop warnings in gcc 8+
KBUILD_CFLAGS += $(call cc-disable-warning, stringop-truncation)

727 728 729 730
KBUILD_CFLAGS += $(call cc-disable-warning, zero-length-bounds)
KBUILD_CFLAGS += $(call cc-disable-warning, array-bounds)
KBUILD_CFLAGS += $(call cc-disable-warning, stringop-overflow)

731 732 733
# Enabled with W=2, disabled by default as noisy
KBUILD_CFLAGS += $(call cc-disable-warning, maybe-uninitialized)

734 735 736
# change __FILE__ to the relative path from the srctree
KBUILD_CFLAGS	+= $(call cc-option,-fmacro-prefix-map=$(srctree)/=)

737 738 739 740 741 742
KBUILD_CFLAGS	+= -g
# $(KBUILD_AFLAGS) sets -g, which causes gcc to pass a suitable -g<format>
# option to the assembler.
KBUILD_AFLAGS	+= -g

# Report stack usage if supported
743 744 745
# ARC tools based on GCC 7.1 has an issue with stack usage
# with naked functions, see commit message for more details
ifndef CONFIG_ARC
746 747 748
ifeq ($(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-stack-usage.sh $(CC)),y)
	KBUILD_CFLAGS += -fstack-usage
endif
749
endif
750 751

KBUILD_CFLAGS += $(call cc-option,-Wno-format-nonliteral)
752 753
KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)

754
ifdef CONFIG_CC_IS_CLANG
755 756 757
KBUILD_CPPFLAGS += $(call cc-option,-Qunused-arguments,)
KBUILD_CFLAGS += $(call cc-disable-warning, format-invalid-specifier)
KBUILD_CFLAGS += $(call cc-disable-warning, gnu)
758 759 760 761 762 763 764
KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
# Quiet clang warning: comparison of unsigned expression < 0 is always false
KBUILD_CFLAGS += $(call cc-disable-warning, tautological-compare)
# CLANG uses a _MergedGlobals as optimization, but this breaks modpost, as the
# source of a reference will be _MergedGlobals and not on of the whitelisted names.
# See modpost pattern 2
KBUILD_CFLAGS += $(call cc-option, -mno-global-merge,)
765
KBUILD_CFLAGS += $(call cc-option, -fcatch-undefined-behavior)
766
endif
767 768 769 770

# These warnings generated too much noise in a regular build.
# Use make W=1 to enable them (see scripts/Makefile.extrawarn)
KBUILD_CFLAGS += $(call cc-disable-warning, unused-but-set-variable)
771

772 773 774
# Prohibit date/time macros, which would make the build non-deterministic
KBUILD_CFLAGS   += $(call cc-option,-Werror=date-time)

775
include scripts/Makefile.extrawarn
776

777 778 779 780 781
# Add user supplied CPPFLAGS, AFLAGS and CFLAGS as the last assignments
KBUILD_CPPFLAGS += $(KCPPFLAGS)
KBUILD_AFLAGS += $(KAFLAGS)
KBUILD_CFLAGS += $(KCFLAGS)

782 783
KBUILD_HOSTCFLAGS += $(if $(CONFIG_TOOLS_DEBUG),-g)

784 785
# Use UBOOTINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
786
UBOOTINCLUDE    := \
787 788 789 790 791 792 793 794 795
	-Iinclude \
	$(if $(KBUILD_SRC), -I$(srctree)/include) \
	$(if $(CONFIG_$(SPL_)SYS_THUMB_BUILD), \
		$(if $(CONFIG_HAS_THUMB2), \
			$(if $(CONFIG_CPU_V7M), \
				-I$(srctree)/arch/arm/thumb1/include), \
			-I$(srctree)/arch/arm/thumb1/include)) \
	-I$(srctree)/arch/$(ARCH)/include \
	-include $(srctree)/include/linux/kconfig.h
796 797 798 799

NOSTDINC_FLAGS += -nostdinc -isystem $(shell $(CC) -print-file-name=include)

# FIX ME
M
Masahiro Yamada 已提交
800 801
cpp_flags := $(KBUILD_CPPFLAGS) $(PLATFORM_CPPFLAGS) $(UBOOTINCLUDE) \
							$(NOSTDINC_FLAGS)
802 803
c_flags := $(KBUILD_CFLAGS) $(cpp_flags)

W
wdenk 已提交
804 805 806
#########################################################################
# U-Boot objects....order is important (i.e. start must be first)

807
HAVE_VENDOR_COMMON_LIB = $(if $(wildcard $(srctree)/board/$(VENDOR)/common/Makefile),y,n)
808

S
Simon Glass 已提交
809
libs-$(CONFIG_API) += api/
810
libs-$(HAVE_VENDOR_COMMON_LIB) += board/$(VENDOR)/common/
S
Simon Glass 已提交
811 812
libs-y += cmd/
libs-y += common/
813
libs-$(CONFIG_OF_EMBED) += dts/
S
Simon Glass 已提交
814 815
libs-y += env/
libs-y += lib/
816 817 818 819 820
libs-y += fs/
libs-y += net/
libs-y += disk/
libs-y += drivers/
libs-$(CONFIG_SYS_FSL_DDR) += drivers/ddr/fsl/
821
libs-$(CONFIG_SYS_FSL_MMDC) += drivers/ddr/fsl/
822
libs-$(CONFIG_$(SPL_)ALTERA_SDRAM) += drivers/ddr/altera/
823
libs-y += drivers/usb/cdns3/
824
libs-y += drivers/usb/dwc3/
825
libs-y += drivers/usb/common/
826
libs-y += drivers/usb/emul/
827
libs-y += drivers/usb/eth/
828
libs-$(CONFIG_USB_DEVICE) += drivers/usb/gadget/
829 830
libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/
libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/udc/
T
Tom Rini 已提交
831
libs-y += drivers/usb/host/
C
Chunfeng Yun 已提交
832
libs-y += drivers/usb/mtu3/
833 834 835 836
libs-y += drivers/usb/musb/
libs-y += drivers/usb/musb-new/
libs-y += drivers/usb/phy/
libs-y += drivers/usb/ulpi/
S
Simon Glass 已提交
837 838 839
ifdef CONFIG_POST
libs-y += post/
endif
840
libs-$(CONFIG_UNIT_TEST) += test/
841
libs-$(CONFIG_UT_ENV) += test/env/
H
Heiko Stuebner 已提交
842
libs-$(CONFIG_UT_OPTEE) += test/optee/
843
libs-$(CONFIG_UT_OVERLAY) += test/overlay/
844

845
libs-y += $(if $(BOARDDIR),board/$(BOARDDIR)/)
846 847

libs-y := $(sort $(libs-y))
848

849 850 851 852 853 854 855 856
u-boot-dirs	:= $(patsubst %/,%,$(filter %/, $(libs-y))) tools examples

u-boot-alldirs	:= $(sort $(u-boot-dirs) $(patsubst %/,%,$(filter %/, $(libs-))))

libs-y		:= $(patsubst %/, %/built-in.o, $(libs-y))

u-boot-init := $(head-y)
u-boot-main := $(libs-y)
857

W
wdenk 已提交
858

W
wdenk 已提交
859
# Add GCC lib
860
ifeq ($(CONFIG_USE_PRIVATE_LIBGCC),y)
861
PLATFORM_LIBGCC = arch/$(ARCH)/lib/lib.a
862
else
863
PLATFORM_LIBGCC := -L $(shell dirname `$(CC) $(c_flags) -print-libgcc-file-name`) -lgcc
864 865
endif
PLATFORM_LIBS += $(PLATFORM_LIBGCC)
866 867 868 869 870 871

ifdef CONFIG_CC_COVERAGE
KBUILD_CFLAGS += --coverage
PLATFORM_LIBGCC += -lgcov
endif

872
export PLATFORM_LIBS
873
export PLATFORM_LIBGCC
W
wdenk 已提交
874

875 876 877 878
# Special flags for CPP when processing the linker script.
# Pass the version down so we can handle backwards compatibility
# on the fly.
LDPPFLAGS += \
879
	-include $(srctree)/include/u-boot/u-boot.lds.h \
880
	-DCPUDIR=$(CPUDIR) \
881 882 883
	$(shell $(LD) --version | \
	  sed -ne 's/GNU ld version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/-DLD_MAJOR=\1 -DLD_MINOR=\2/p')

884
#########################################################################
W
wdenk 已提交
885 886
#########################################################################

887
ifneq ($(CONFIG_BOARD_SIZE_LIMIT),)
888
BOARD_SIZE_CHECK= @ $(call size_check,$@,$(CONFIG_BOARD_SIZE_LIMIT))
889 890 891 892
else
BOARD_SIZE_CHECK =
endif

893
ifneq ($(CONFIG_SPL_SIZE_LIMIT),0x0)
894
SPL_SIZE_CHECK = @$(call size_check,$@,$$(tools/spl_size_limit))
895 896 897 898
else
SPL_SIZE_CHECK =
endif

899
ifneq ($(CONFIG_TPL_SIZE_LIMIT),0x0)
S
Simon Glass 已提交
900 901 902 903 904
TPL_SIZE_CHECK = @$(call size_check,$@,$(CONFIG_TPL_SIZE_LIMIT))
else
TPL_SIZE_CHECK =
endif

905
# Statically apply RELA-style relocations (currently arm64 only)
906 907 908
# This is useful for arm64 where static relocation needs to be performed on
# the raw binary, but certain simulators only accept an ELF file (but don't
# do the relocation).
909 910
ifneq ($(CONFIG_STATIC_RELA),)
# $(1) is u-boot ELF, $(2) is u-boot bin, $(3) is text base
911 912 913 914 915
quiet_cmd_static_rela = RELOC   $@
cmd_static_rela = \
	start=$$($(NM) $(2) | grep __rel_dyn_start | cut -f 1 -d ' '); \
	end=$$($(NM) $(2) | grep __rel_dyn_end | cut -f 1 -d ' '); \
	tools/relocate-rela $(3) $(4) $$start $$end
916
else
917
quiet_cmd_static_rela =
918
cmd_static_rela =
919 920
endif

S
Simon Glass 已提交
921 922
# Always append INPUTS so that arch config.mk's can add custom ones
INPUTS-y += u-boot.srec u-boot.bin u-boot.sym System.map binary_size_check
923

S
Simon Glass 已提交
924
INPUTS-$(CONFIG_ONENAND_U_BOOT) += u-boot-onenand.bin
925
ifeq ($(CONFIG_SPL_FSL_PBL),y)
S
Simon Glass 已提交
926
INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot-with-spl-pbl.bin
927
else
T
Tom Rini 已提交
928
ifneq ($(CONFIG_NXP_ESBC), y)
929 930
# For Secure Boot The Image needs to be signed and Header must also
# be included. So The image has to be built explicitly
S
Simon Glass 已提交
931
INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot.pbl
932
endif
933
endif
S
Simon Glass 已提交
934
INPUTS-$(CONFIG_SPL) += spl/u-boot-spl.bin
935
ifeq ($(CONFIG_MX6)$(CONFIG_IMX_HAB), yy)
S
Simon Glass 已提交
936
INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
937
else
938
ifeq ($(CONFIG_MX7)$(CONFIG_IMX_HAB), yy)
S
Simon Glass 已提交
939
INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
940
else
S
Simon Glass 已提交
941
INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot.img
942
endif
943
endif
S
Simon Glass 已提交
944 945
INPUTS-$(CONFIG_TPL) += tpl/u-boot-tpl.bin
INPUTS-$(CONFIG_OF_SEPARATE) += u-boot.dtb
946
INPUTS-$(CONFIG_BINMAN_STANDALONE_FDT) += u-boot.dtb
947
ifeq ($(CONFIG_SPL_FRAMEWORK),y)
S
Simon Glass 已提交
948
INPUTS-$(CONFIG_OF_SEPARATE) += u-boot-dtb.img
949
endif
I
Ilias Apalodimas 已提交
950
INPUTS-$(CONFIG_SANDBOX) += u-boot.dtb
951
ifneq ($(CONFIG_SPL_TARGET),)
S
Simon Glass 已提交
952
INPUTS-$(CONFIG_SPL) += $(CONFIG_SPL_TARGET:"%"=%)
953
endif
S
Simon Glass 已提交
954 955 956
INPUTS-$(CONFIG_REMAKE_ELF) += u-boot.elf
INPUTS-$(CONFIG_EFI_APP) += u-boot-app.efi
INPUTS-$(CONFIG_EFI_STUB) += u-boot-payload.efi
957

958 959
# Generate this input file for binman
ifeq ($(CONFIG_SPL),)
S
Simon Glass 已提交
960
INPUTS-$(CONFIG_ARCH_MEDIATEK) += u-boot-mtk.bin
961
endif
962

963 964
# Add optional build target if defined in board/cpu/soc headers
ifneq ($(CONFIG_BUILD_TARGET),)
S
Simon Glass 已提交
965
INPUTS-y += $(CONFIG_BUILD_TARGET:"%"=%)
966 967
endif

968
ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
S
Simon Glass 已提交
969
INPUTS-y += init_sp_bss_offset_check
970 971
endif

972
ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
S
Simon Glass 已提交
973
INPUTS-y += u-boot-with-dtb.bin
974 975
endif

976 977 978 979 980
ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
# On ARM64 this target is produced by binman so we don't need this dep
ifeq ($(CONFIG_ARM64),y)
ifeq ($(CONFIG_SPL),y)
# TODO: Get binman to generate this too
S
Simon Glass 已提交
981
INPUTS-y += u-boot-rockchip.bin
982
endif
983 984 985 986 987 988 989
else
ifeq ($(CONFIG_SPL),y)
# Generate these inputs for binman which will create the output files
INPUTS-y += idbloader.img u-boot.img
endif
endif
endif
990

991 992 993 994
INPUTS-$(CONFIG_X86) += u-boot-x86-start16.bin u-boot-x86-reset16.bin \
	$(if $(CONFIG_SPL_X86_16BIT_INIT),spl/u-boot-spl.bin) \
	$(if $(CONFIG_TPL_X86_16BIT_INIT),tpl/u-boot-tpl.bin)

995
LDFLAGS_u-boot += $(LDFLAGS_FINAL)
996 997 998 999

# Avoid 'Not enough room for program headers' error on binutils 2.28 onwards.
LDFLAGS_u-boot += $(call ld-option, --no-dynamic-linker)

1000 1001 1002
# ld.lld support
LDFLAGS_u-boot += -z notext

M
Marek Behún 已提交
1003 1004
LDFLAGS_u-boot += --build-id=none

1005
ifeq ($(CONFIG_ARC)$(CONFIG_NIOS2)$(CONFIG_X86)$(CONFIG_XTENSA),)
1006 1007
LDFLAGS_u-boot += -Ttext $(CONFIG_SYS_TEXT_BASE)
endif
1008

1009 1010 1011 1012 1013 1014
# insure the checker run with the right endianness
CHECKFLAGS += $(if $(CONFIG_CPU_BIG_ENDIAN),-mbig-endian,-mlittle-endian)

# the checker needs the correct machine size
CHECKFLAGS += $(if $(CONFIG_64BIT),-m64,-m32)

1015
# Normally we fill empty space with 0xff
1016
quiet_cmd_objcopy = OBJCOPY $@
1017 1018 1019 1020 1021 1022
cmd_objcopy = $(OBJCOPY) --gap-fill=0xff $(OBJCOPYFLAGS) \
	$(OBJCOPYFLAGS_$(@F)) $< $@

# Provide a version which does not do this, for use by EFI
quiet_cmd_zobjcopy = OBJCOPY $@
cmd_zobjcopy = $(OBJCOPY) $(OBJCOPYFLAGS) $(OBJCOPYFLAGS_$(@F)) $< $@
1023

1024 1025 1026
quiet_cmd_efipayload = OBJCOPY $@
cmd_efipayload = $(OBJCOPY) -I binary -O $(EFIPAYLOAD_BFDTARGET) -B $(EFIPAYLOAD_BFDARCH) $< $@

1027 1028
MKIMAGEOUTPUT ?= /dev/null

M
Marek Vasut 已提交
1029
quiet_cmd_mkimage = MKIMAGE $@
1030
cmd_mkimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) -d $< $@ \
1031
	>$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1032

1033
quiet_cmd_mkfitimage = MKIMAGE $@
1034 1035
cmd_mkfitimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) \
	-f $(U_BOOT_ITS) -p $(CONFIG_FIT_EXTERNAL_OFFSET) $@ \
1036
	>$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1037

1038 1039 1040
quiet_cmd_cat = CAT     $@
cmd_cat = cat $(filter-out $(PHONY), $^) > $@

1041 1042 1043
append = cat $(filter-out $< $(PHONY), $^) >> $@

quiet_cmd_pad_cat = CAT     $@
1044
cmd_pad_cat = $(cmd_objcopy) && $(append) || { rm -f $@; false; }
1045

1046 1047 1048
quiet_cmd_lzma = LZMA    $@
cmd_lzma = lzma -c -z -k -9 $< > $@

1049 1050
cfg: u-boot.cfg

1051 1052 1053 1054
quiet_cmd_cfgcheck = CFGCHK  $2
cmd_cfgcheck = $(srctree)/scripts/check-config.sh $2 \
		$(srctree)/scripts/config_whitelist.txt $(srctree)

1055 1056 1057 1058 1059 1060 1061 1062 1063 1064 1065 1066 1067 1068 1069
# Concat the value of all the CONFIGs (result is 'y' or 'yy', etc. )
got = $(foreach cfg,$(1),$($(cfg)))

# expected value 'y for each one
expect = $(foreach cfg,$(1),y)

# Show a deprecation message
# Args:
# 1: List of CONFIG_DM_... to migrate to (e.g. "CONFIG_DM_MMC CONFIG_BLK")
# 2: Name of component (e.g . "Ethernet drivers")
# 3: Release deadline (e.g. "v202.07")
# 4: Condition to require before checking (e.g. "$(CONFIG_NET)")
# Note: Script avoids bash construct, hence the strange double 'if'
# (patches welcome!)
define deprecated
1070
	@if [ -n "$(strip $(4))" ]; then if [ "$(got)" != "$(expect)" ]; then \
1071 1072 1073 1074 1075 1076 1077 1078 1079 1080 1081
		echo >&2 "===================== WARNING ======================"; \
		echo >&2 "This board does not use $(firstword $(1)) (Driver Model"; \
		echo >&2 "for $(2)). Please update the board to use"; \
		echo >&2 "$(firstword $(1)) before the $(3) release. Failure to"; \
		echo >&2 "update by the deadline may result in board removal."; \
		echo >&2 "See doc/driver-model/migration.rst for more info."; \
		echo >&2 "===================================================="; \
	fi; fi

endef

S
Simon Glass 已提交
1082 1083 1084
PHONY += inputs
inputs: $(INPUTS-y)

1085 1086 1087 1088 1089 1090 1091 1092
all: .binman_stamp inputs
ifeq ($(CONFIG_BINMAN),y)
	$(call if_changed,binman)
endif

# Timestamp file to make sure that binman always runs
.binman_stamp: FORCE
	@touch $@
S
Simon Glass 已提交
1093

1094 1095 1096
ifeq ($(CONFIG_DEPRECATED),y)
	$(warning "You have deprecated configuration options enabled in your .config! Please check your configuration.")
endif
1097 1098 1099 1100 1101 1102 1103 1104 1105 1106 1107 1108 1109 1110 1111
ifeq ($(CONFIG_OF_EMBED),y)
	@echo >&2 "===================== WARNING ======================"
	@echo >&2 "CONFIG_OF_EMBED is enabled. This option should only"
	@echo >&2 "be used for debugging purposes. Please use"
	@echo >&2 "CONFIG_OF_SEPARATE for boards in mainline."
	@echo >&2 "See doc/README.fdt-control for more info."
	@echo >&2 "===================================================="
endif
ifneq ($(CONFIG_SPL_FIT_GENERATOR),)
	@echo >&2 "===================== WARNING ======================"
	@echo >&2 "This board uses CONFIG_SPL_FIT_GENERATOR. Please migrate"
	@echo >&2 "to binman instead, to avoid the proliferation of"
	@echo >&2 "arch-specific scripts with no tests."
	@echo >&2 "===================================================="
endif
1112 1113 1114 1115 1116 1117 1118 1119
ifneq ($(CONFIG_DM),y)
	@echo >&2 "===================== WARNING ======================"
	@echo >&2 "This board does not use CONFIG_DM. CONFIG_DM will be"
	@echo >&2 "compulsory starting with the v2020.01 release."
	@echo >&2 "Failure to update may result in board removal."
	@echo >&2 "See doc/driver-model/migration.rst for more info."
	@echo >&2 "===================================================="
endif
1120 1121
	$(call deprecated,CONFIG_WDT,DM watchdog,v2019.10,\
		$(CONFIG_WATCHDOG)$(CONFIG_HW_WATCHDOG))
1122
	$(call deprecated,CONFIG_DM_ETH,Ethernet drivers,v2020.07,$(CONFIG_NET))
S
Simon Glass 已提交
1123
	$(call deprecated,CONFIG_DM_I2C,I2C drivers,v2022.04,$(CONFIG_SYS_I2C_LEGACY))
1124 1125 1126
	@# Check that this build does not use CONFIG options that we do not
	@# know about unless they are in Kconfig. All the existing CONFIG
	@# options are whitelisted, so new ones should not be added.
1127
	$(call cmd,cfgcheck,u-boot.cfg)
W
wdenk 已提交
1128

1129
PHONY += dtbs
1130 1131
dtbs: dts/dt.dtb
	@:
1132
dts/dt.dtb: u-boot
1133
	$(Q)$(MAKE) $(build)=dts dtbs
1134

1135 1136 1137
quiet_cmd_copy = COPY    $@
      cmd_copy = cp $< $@

1138
ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1139

1140 1141 1142 1143 1144 1145 1146 1147 1148 1149 1150 1151 1152 1153
ifeq ($(CONFIG_MULTI_DTB_FIT_LZO),y)
FINAL_DTB_CONTAINER = fit-dtb.blob.lzo
else ifeq ($(CONFIG_MULTI_DTB_FIT_GZIP),y)
FINAL_DTB_CONTAINER = fit-dtb.blob.gz
else
FINAL_DTB_CONTAINER = fit-dtb.blob
endif

fit-dtb.blob.gz: fit-dtb.blob
	@gzip -kf9 $< > $@

fit-dtb.blob.lzo: fit-dtb.blob
	@lzop -f9 $< > $@

1154 1155
fit-dtb.blob: dts/dt.dtb FORCE
	$(call if_changed,mkimage)
1156 1157 1158 1159
ifneq ($(SOURCE_DATE_EPOCH),)
	touch -d @$(SOURCE_DATE_EPOCH) fit-dtb.blob
	chmod 0600 fit-dtb.blob
endif
1160 1161 1162 1163 1164

MKIMAGEFLAGS_fit-dtb.blob = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
	-a 0 -e 0 -E \
	$(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) -d /dev/null

1165 1166
MKIMAGEFLAGS_fit-dtb.blob += -B 0x8

1167 1168 1169 1170
ifneq ($(EXT_DTB),)
u-boot-fit-dtb.bin: u-boot-nodtb.bin $(EXT_DTB)
		$(call if_changed,cat)
else
1171
u-boot-fit-dtb.bin: u-boot-nodtb.bin $(FINAL_DTB_CONTAINER)
1172
	$(call if_changed,cat)
1173
endif
1174 1175 1176

u-boot.bin: u-boot-fit-dtb.bin FORCE
	$(call if_changed,copy)
1177 1178 1179 1180

u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
	$(call if_changed,cat)

1181
else ifeq ($(CONFIG_OF_SEPARATE),y)
1182
u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1183
	$(call if_changed,cat)
1184

1185 1186 1187 1188 1189 1190 1191
u-boot.bin: u-boot-dtb.bin FORCE
	$(call if_changed,copy)
else
u-boot.bin: u-boot-nodtb.bin FORCE
	$(call if_changed,copy)
endif

1192 1193 1194 1195 1196 1197 1198 1199 1200
# we call Makefile in arch/arm/mach-imx which
# has targets which are dependent on targets defined
# here. make could not resolve them and we must ensure
# that they are finished before calling imx targets
ifeq ($(CONFIG_MULTI_DTB_FIT),y)
IMX_DEPS = u-boot-fit-dtb.bin
endif

%.imx: $(IMX_DEPS) %.bin
1201
	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1202
	$(BOARD_SIZE_CHECK)
1203

1204 1205 1206 1207 1208 1209
%.vyb: %.imx
	$(Q)$(MAKE) $(build)=arch/arm/cpu/armv7/vf610 $@

quiet_cmd_copy = COPY    $@
      cmd_copy = cp $< $@

1210 1211 1212
u-boot.dtb: dts/dt.dtb
	$(call cmd,copy)

1213
OBJCOPYFLAGS_u-boot.hex := -O ihex
W
wdenk 已提交
1214

1215
OBJCOPYFLAGS_u-boot.srec := -O srec
W
wdenk 已提交
1216

1217 1218 1219
u-boot.hex u-boot.srec: u-boot FORCE
	$(call if_changed,objcopy)

1220 1221 1222 1223 1224
OBJCOPYFLAGS_u-boot-elf.srec := $(OBJCOPYFLAGS_u-boot.srec)

u-boot-elf.srec: u-boot.elf FORCE
	$(call if_changed,objcopy)

1225 1226 1227 1228 1229
OBJCOPYFLAGS_u-boot-spl.srec = $(OBJCOPYFLAGS_u-boot.srec)

spl/u-boot-spl.srec: spl/u-boot-spl FORCE
	$(call if_changed,objcopy)

1230 1231 1232
%.scif: %.srec
	$(Q)$(MAKE) $(build)=arch/arm/mach-rmobile $@

1233
OBJCOPYFLAGS_u-boot-nodtb.bin := -O binary \
1234 1235
		$(if $(CONFIG_X86_16BIT_INIT),-R .start16 -R .resetvec) \
		$(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR),-R .bootpg -R .resetvec)
1236

1237 1238
binary_size_check: u-boot-nodtb.bin FORCE
	@file_size=$(shell wc -c u-boot-nodtb.bin | awk '{print $$1}') ; \
1239
	map_size=$(shell cat u-boot.map | \
1240
		awk '/_image_copy_start/ {start = $$1} /_image_binary_end/ {end = $$1} END {if (start != "" && end != "") print "ibase=16; " toupper(end) " - " toupper(start)}' \
1241
		| sed 's/0X//g' \
1242
		| bc); \
1243 1244
	if [ "" != "$$map_size" ]; then \
		if test $$map_size -ne $$file_size; then \
1245
			echo "u-boot.map shows a binary size of $$map_size" >&2 ; \
1246
			echo "  but u-boot-nodtb.bin shows $$file_size" >&2 ; \
1247 1248 1249 1250
			exit 1; \
		fi \
	fi

1251
ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
1252 1253 1254 1255 1256 1257 1258 1259 1260 1261 1262 1263 1264 1265 1266 1267 1268 1269 1270 1271 1272 1273 1274 1275 1276 1277
ifneq ($(CONFIG_SYS_MALLOC_F_LEN),)
subtract_sys_malloc_f_len = space=$$(($${space} - $(CONFIG_SYS_MALLOC_F_LEN)))
else
subtract_sys_malloc_f_len = true
endif
# The 1/4 margin below is somewhat arbitrary. The likely initial SP usage is
# so low that the DTB could probably use 90%+ of the available space, for
# current values of CONFIG_SYS_INIT_SP_BSS_OFFSET at least. However, let's be
# safe for now and tweak this later if space becomes tight.
# A rejected alternative would be to check that some absolute minimum stack
# space was available. However, since CONFIG_SYS_INIT_SP_BSS_OFFSET is
# deliberately build-specific, to take account of build-to-build stack usage
# differences due to different feature sets, there is no common absolute value
# to check against.
init_sp_bss_offset_check: u-boot.dtb FORCE
	@dtb_size=$(shell wc -c u-boot.dtb | awk '{print $$1}') ; \
	space=$(CONFIG_SYS_INIT_SP_BSS_OFFSET) ; \
	$(subtract_sys_malloc_f_len) ; \
	quarter_space=$$(($${space} / 4)) ; \
	if [ $${dtb_size} -gt $${quarter_space} ]; then \
		echo "u-boot.dtb is larger than 1 quarter of " >&2 ; \
		echo "(CONFIG_SYS_INIT_SP_BSS_OFFSET - CONFIG_SYS_MALLOC_F_LEN)" >&2 ; \
		exit 1 ; \
	fi
endif

P
Pali Rohár 已提交
1278
shell_cmd = { $(call echo-cmd,$(1)) $(cmd_$(1)); }
1279 1280

quiet_cmd_objcopy_uboot = OBJCOPY $@
1281
ifdef cmd_static_rela
1282
cmd_objcopy_uboot = $(cmd_objcopy) && $(call shell_cmd,static_rela,$<,$@,$(CONFIG_SYS_TEXT_BASE)) || { rm -f $@; false; }
1283 1284 1285
else
cmd_objcopy_uboot = $(cmd_objcopy)
endif
1286

1287
u-boot-nodtb.bin: u-boot FORCE
1288
	$(call if_changed,objcopy_uboot)
1289
	$(BOARD_SIZE_CHECK)
W
wdenk 已提交
1290

1291
u-boot.ldr:	u-boot
1292
		$(CREATE_LDR_ENV)
1293
		$(LDR) -T $(CONFIG_CPU) -c $@ $< $(LDR_FLAGS)
1294
		$(BOARD_SIZE_CHECK)
1295

S
Simon Glass 已提交
1296 1297
# binman
# ---------------------------------------------------------------------------
1298
# Use 'make BINMAN_DEBUG=1' to enable debugging
1299
# Use 'make BINMAN_VERBOSE=3' to set vebosity level
1300
default_dt := $(if $(DEVICE_TREE),$(DEVICE_TREE),$(CONFIG_DEFAULT_DEVICE_TREE))
1301

S
Simon Glass 已提交
1302
quiet_cmd_binman = BINMAN  $@
1303
cmd_binman = $(srctree)/tools/binman/binman $(if $(BINMAN_DEBUG),-D) \
1304
                --toolpath $(objtree)/tools \
1305
		$(if $(BINMAN_VERBOSE),-v$(BINMAN_VERBOSE)) \
1306
		build -u -d u-boot.dtb -O . -m --allow-missing \
1307
		-I . -I $(srctree) -I $(srctree)/board/$(BOARDDIR) \
1308 1309
		-I arch/$(ARCH)/dts -a of-list=$(CONFIG_OF_LIST) \
		-a atf-bl31-path=${BL31} \
1310
		-a opensbi-path=${OPENSBI} \
1311
		-a default-dt=$(default_dt) \
1312
		-a scp-path=$(SCP) \
1313 1314
		-a spl-bss-pad=$(if $(CONFIG_SPL_SEPARATE_BSS),,1) \
		-a tpl-bss-pad=$(if $(CONFIG_TPL_SEPARATE_BSS),,1) \
1315 1316
		-a spl-dtb=$(CONFIG_SPL_OF_REAL) \
		-a tpl-dtb=$(CONFIG_SPL_OF_REAL) \
1317
		$(BINMAN_$(@F))
S
Simon Glass 已提交
1318

1319 1320 1321
OBJCOPYFLAGS_u-boot.ldr.hex := -I binary -O ihex

OBJCOPYFLAGS_u-boot.ldr.srec := -I binary -O srec
1322

1323 1324
u-boot.ldr.hex u-boot.ldr.srec: u-boot.ldr FORCE
	$(call if_changed,objcopy)
1325

1326 1327 1328 1329 1330
#
# U-Boot entry point, needed for booting of full-blown U-Boot
# from the SPL U-Boot version.
#
ifndef CONFIG_SYS_UBOOT_START
1331
CONFIG_SYS_UBOOT_START := $(CONFIG_SYS_TEXT_BASE)
1332 1333
endif

1334
# Boards with more complex image requirements can provide an .its source file
1335
# or a generator script
1336 1337
# NOTE: Please do not use this. We are migrating away from Makefile rules to use
# binman instead.
1338
ifneq ($(CONFIG_SPL_FIT_SOURCE),"")
1339 1340 1341
U_BOOT_ITS := u-boot.its
$(U_BOOT_ITS): $(subst ",,$(CONFIG_SPL_FIT_SOURCE))
	$(call if_changed,copy)
1342
else
1343
ifneq ($(CONFIG_USE_SPL_FIT_GENERATOR),)
1344
U_BOOT_ITS := u-boot.its
1345 1346 1347 1348
ifeq ($(CONFIG_SPL_FIT_GENERATOR),"arch/arm/mach-rockchip/make_fit_atf.py")
U_BOOT_ITS_DEPS += u-boot
endif
$(U_BOOT_ITS): $(U_BOOT_ITS_DEPS) FORCE
1349 1350 1351 1352 1353
	$(srctree)/$(CONFIG_SPL_FIT_GENERATOR) \
	$(patsubst %,arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) > $@
endif
endif

1354 1355 1356
ifdef CONFIG_SPL_LOAD_FIT
MKIMAGEFLAGS_u-boot.img = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
	-a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1357
	-p $(CONFIG_FIT_EXTERNAL_OFFSET) \
1358
	-n "U-Boot $(UBOOTRELEASE) for $(BOARD) board" -E \
1359
	$(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(DEVICE_TREE))) \
1360 1361
	$(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) \
	$(patsubst %,-b arch/$(ARCH)/dts/%.dtbo,$(subst ",,$(CONFIG_OF_OVERLAY_LIST)))
1362
else
1363 1364 1365
MKIMAGEFLAGS_u-boot.img = -A $(ARCH) -T firmware -C none -O u-boot \
	-a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
	-n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1366 1367 1368
MKIMAGEFLAGS_u-boot-ivt.img = -A $(ARCH) -T firmware_ivt -C none -O u-boot \
	-a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
	-n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1369
u-boot-ivt.img: MKIMAGEOUTPUT = u-boot-ivt.img.log
1370
endif
1371

1372 1373
MKIMAGEFLAGS_u-boot-dtb.img = $(MKIMAGEFLAGS_u-boot.img)

1374 1375 1376 1377 1378 1379 1380 1381 1382 1383 1384 1385
# Some boards have the kwbimage.cfg file written in advance, while some
# other boards generate it on the fly during the build in the build tree.
# Let's check if the file exists in the build tree first, otherwise we
# fall back to use the one in the source tree.
KWD_CONFIG_FILE = $(shell \
	if [ -f $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%) ]; then \
		echo -n $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
	else \
		echo -n $(srctree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
	fi)

MKIMAGEFLAGS_u-boot.kwb = -n $(KWD_CONFIG_FILE) \
1386
	-T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE)
1387

1388
MKIMAGEFLAGS_u-boot-spl.kwb = -n $(KWD_CONFIG_FILE) \
1389
	-T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
M
Mario Six 已提交
1390
	$(if $(KEYDIR),-k $(KEYDIR))
1391

1392 1393
MKIMAGEFLAGS_u-boot.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
		-R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage
1394

1395 1396 1397 1398 1399 1400
ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
UBOOT_BIN := u-boot-with-dtb.bin
else
UBOOT_BIN := u-boot.bin
endif

1401 1402 1403 1404 1405 1406 1407 1408 1409 1410
MKIMAGEFLAGS_u-boot-lzma.img = -A $(ARCH) -T standalone -C lzma -O u-boot \
	-a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
	-n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"

u-boot.bin.lzma: u-boot.bin FORCE
	$(call if_changed,lzma)

u-boot-lzma.img: u-boot.bin.lzma FORCE
	$(call if_changed,mkimage)

1411
u-boot-dtb.img u-boot.img u-boot.kwb u-boot.pbl u-boot-ivt.img: \
1412
		$(if $(CONFIG_SPL_LOAD_FIT),u-boot-nodtb.bin \
I
Ilias Apalodimas 已提交
1413
			$(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SANDBOX)$(CONFIG_BINMAN_STANDALONE_FDT),dts/dt.dtb) \
1414
		,$(UBOOT_BIN)) FORCE
1415
	$(call if_changed,mkimage)
1416
	$(BOARD_SIZE_CHECK)
1417

1418 1419 1420 1421 1422
ifeq ($(CONFIG_SPL_LOAD_FIT_FULL),y)
MKIMAGEFLAGS_u-boot.itb =
else
MKIMAGEFLAGS_u-boot.itb = -E
endif
1423
MKIMAGEFLAGS_u-boot.itb += -B 0x8
1424

1425
ifdef U_BOOT_ITS
1426
u-boot.itb: u-boot-nodtb.bin \
I
Ilias Apalodimas 已提交
1427
		$(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SANDBOX),dts/dt.dtb) \
1428
		$(U_BOOT_ITS) FORCE
1429
	$(call if_changed,mkfitimage)
1430
	$(BOARD_SIZE_CHECK)
1431
endif
1432

1433
u-boot-spl.kwb: u-boot.bin spl/u-boot-spl.bin FORCE
1434 1435
	$(call if_changed,mkimage)

1436 1437
u-boot.sha1:	u-boot.bin
		tools/ubsha1 u-boot.bin
1438

1439
u-boot.dis:	u-boot
W
wdenk 已提交
1440 1441
		$(OBJDUMP) -d $< > $@

Y
York Sun 已提交
1442 1443
ifneq ($(CONFIG_SPL_PAYLOAD),)
SPL_PAYLOAD := $(CONFIG_SPL_PAYLOAD:"%"=%)
1444
else
1445
SPL_PAYLOAD := u-boot.bin
1446
endif
1447

1448 1449
SPL_IMAGE := $(CONFIG_SPL_IMAGE:"%"=%)

1450 1451
OBJCOPYFLAGS_u-boot-with-spl.bin = -I binary -O binary \
				   --pad-to=$(CONFIG_SPL_PAD_TO)
1452
u-boot-with-spl.bin: $(SPL_IMAGE) $(SPL_PAYLOAD) FORCE
1453
	$(call if_changed,pad_cat)
1454

1455
ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
J
Jagan Teki 已提交
1456

1457 1458
# TPL + SPL
ifeq ($(CONFIG_SPL)$(CONFIG_TPL),yy)
1459
MKIMAGEFLAGS_u-boot-tpl-rockchip.bin = -n $(CONFIG_SYS_SOC) -T rksd
1460
tpl/u-boot-tpl-rockchip.bin: tpl/u-boot-tpl.bin FORCE
1461
	$(call if_changed,mkimage)
1462
idbloader.img: tpl/u-boot-tpl-rockchip.bin spl/u-boot-spl.bin FORCE
1463
	$(call if_changed,cat)
1464
else
1465
MKIMAGEFLAGS_idbloader.img = -n $(CONFIG_SYS_SOC) -T rksd
1466 1467
idbloader.img: spl/u-boot-spl.bin FORCE
	$(call if_changed,mkimage)
1468 1469
endif

1470
ifeq ($(CONFIG_ARM64),y)
1471 1472 1473 1474 1475 1476 1477
OBJCOPYFLAGS_u-boot-rockchip.bin = -I binary -O binary \
	--pad-to=$(CONFIG_SPL_PAD_TO) --gap-fill=0xff
u-boot-rockchip.bin: idbloader.img u-boot.itb FORCE
	$(call if_changed,pad_cat)
endif # CONFIG_ARM64

endif # CONFIG_ARCH_ROCKCHIP
1478

1479
ifeq ($(CONFIG_ARCH_LPC32XX)$(CONFIG_SPL),yy)
1480 1481 1482 1483 1484 1485 1486
MKIMAGEFLAGS_lpc32xx-spl.img = -T lpc32xximage -a $(CONFIG_SPL_TEXT_BASE)

lpc32xx-spl.img: spl/u-boot-spl.bin FORCE
	$(call if_changed,mkimage)

OBJCOPYFLAGS_lpc32xx-boot-0.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)

1487
lpc32xx-boot-0.bin: lpc32xx-spl.img FORCE
1488 1489 1490 1491
	$(call if_changed,objcopy)

OBJCOPYFLAGS_lpc32xx-boot-1.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)

1492
lpc32xx-boot-1.bin: lpc32xx-spl.img FORCE
1493 1494
	$(call if_changed,objcopy)

1495
lpc32xx-full.bin: lpc32xx-boot-0.bin lpc32xx-boot-1.bin u-boot.img FORCE
1496 1497
	$(call if_changed,cat)

1498
endif
1499

1500 1501 1502 1503
OBJCOPYFLAGS_u-boot-with-tpl.bin = -I binary -O binary \
				   --pad-to=$(CONFIG_TPL_PAD_TO)
tpl/u-boot-with-tpl.bin: tpl/u-boot-tpl.bin u-boot.bin FORCE
	$(call if_changed,pad_cat)
1504

1505
SPL: spl/u-boot-spl.bin FORCE
1506
	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1507

P
Peng Fan 已提交
1508
ifeq ($(CONFIG_ARCH_IMX8M)$(CONFIG_ARCH_IMX8), y)
P
Peng Fan 已提交
1509 1510 1511 1512 1513 1514 1515
ifeq ($(CONFIG_SPL_LOAD_IMX_CONTAINER), y)
u-boot.cnt: u-boot.bin FORCE
	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@

flash.bin: spl/u-boot-spl.bin u-boot.cnt FORCE
	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
else
1516 1517 1518 1519 1520
ifeq ($(CONFIG_BINMAN),y)
flash.bin: spl/u-boot-spl.bin $(INPUTS-y) FORCE
	$(call if_changed,binman)
	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
else
P
Peng Fan 已提交
1521 1522 1523
flash.bin: spl/u-boot-spl.bin u-boot.itb FORCE
	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
endif
P
Peng Fan 已提交
1524
endif
1525
endif
P
Peng Fan 已提交
1526

1527 1528 1529 1530
u-boot.uim: u-boot.bin FORCE
	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@

u-boot-with-spl.imx u-boot-with-nand-spl.imx: SPL $(if $(CONFIG_OF_SEPARATE),u-boot.img,u-boot.uim) FORCE
1531
	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1532

1533 1534 1535 1536
MKIMAGEFLAGS_u-boot.ubl = -n $(UBL_CONFIG) -T ublimage -e $(CONFIG_SYS_TEXT_BASE)

u-boot.ubl: u-boot-with-spl.bin FORCE
	$(call if_changed,mkimage)
1537

1538 1539 1540 1541 1542
MKIMAGEFLAGS_u-boot-spl.ais = -s -n $(if $(CONFIG_AIS_CONFIG_FILE), \
	$(srctree)/$(CONFIG_AIS_CONFIG_FILE:"%"=%),"/dev/null") \
	-T aisimage -e $(CONFIG_SPL_TEXT_BASE)
spl/u-boot-spl.ais: spl/u-boot-spl.bin FORCE
	$(call if_changed,mkimage)
1543

1544
OBJCOPYFLAGS_u-boot.ais = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1545 1546
u-boot.ais: spl/u-boot-spl.ais u-boot.img FORCE
	$(call if_changed,pad_cat)
1547

1548 1549
u-boot-signed.sb: u-boot.bin spl/u-boot-spl.bin
	$(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot-signed.sb
1550
u-boot.sb: u-boot.bin spl/u-boot-spl.bin
1551
	$(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot.sb
1552

1553 1554 1555 1556 1557
MKIMAGEFLAGS_u-boot-spl.img = -A $(ARCH) -T firmware -C none \
	-a $(CONFIG_SPL_TEXT_BASE) -e $(CONFIG_SPL_TEXT_BASE) -n XLOADER
spl/u-boot-spl.img: spl/u-boot-spl.bin FORCE
	$(call if_changed,mkimage)

1558
ifneq ($(CONFIG_ARCH_SOCFPGA),)
1559
quiet_cmd_gensplx4 = GENSPLX4 $@
1560 1561 1562 1563
cmd_gensplx4 = $(OBJCOPY) -I binary -O binary --gap-fill=0x0		\
			--pad-to=$(CONFIG_SPL_PAD_TO)			\
			spl/u-boot-spl.sfp spl/u-boot-spl.sfp &&        \
		cat	spl/u-boot-spl.sfp spl/u-boot-spl.sfp		\
1564
			spl/u-boot-spl.sfp spl/u-boot-spl.sfp > $@ || { rm -f $@; false; }
1565 1566 1567
spl/u-boot-splx4.sfp: spl/u-boot-spl.sfp FORCE
	$(call if_changed,gensplx4)

1568
quiet_cmd_socboot = SOCBOOT $@
1569
cmd_socboot = cat	spl/u-boot-splx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1570
u-boot-with-spl.sfp: spl/u-boot-splx4.sfp u-boot.img FORCE
1571
	$(call if_changed,socboot)
1572

1573 1574
quiet_cmd_gensplpadx4 = GENSPLPADX4 $@
cmd_gensplpadx4 =  dd if=/dev/zero of=spl/u-boot-spl.pad bs=64 count=1024 ; \
1575 1576 1577
		   cat	spl/u-boot-spl.sfp spl/u-boot-spl.pad \
			spl/u-boot-spl.sfp spl/u-boot-spl.pad \
			spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1578
			spl/u-boot-spl.sfp spl/u-boot-spl.pad > $@ || \
1579
			{ rm -f $@ spl/u-boot-spl.pad; false; }
1580 1581 1582 1583
u-boot-spl-padx4.sfp: spl/u-boot-spl.sfp FORCE
	$(call if_changed,gensplpadx4)

quiet_cmd_socnandboot = SOCNANDBOOT $@
1584
cmd_socnandboot = cat	u-boot-spl-padx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1585
u-boot-with-nand-spl.sfp: u-boot-spl-padx4.sfp u-boot.img FORCE
1586 1587
	$(call if_changed,socnandboot)

1588 1589
endif

1590 1591 1592 1593 1594 1595 1596 1597 1598 1599 1600 1601
ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
u-boot-with-dtb.bin: u-boot.bin u-boot.dtb \
	$(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR), u-boot-br.bin) FORCE
	$(call if_changed,binman)

ifeq ($(CONFIG_MPC85XX_HAVE_RESET_VECTOR),y)
OBJCOPYFLAGS_u-boot-br.bin := -O binary -j .bootpg -j .resetvec
u-boot-br.bin: u-boot FORCE
	$(call if_changed,objcopy)
endif
endif

1602 1603 1604 1605
quiet_cmd_ldr = LD      $@
cmd_ldr = $(LD) $(LDFLAGS_$(@F)) \
	       $(filter-out FORCE,$^) -o $@

1606
ifdef CONFIG_X86
1607 1608 1609 1610 1611 1612
OBJCOPYFLAGS_u-boot-x86-start16.bin := -O binary -j .start16
u-boot-x86-start16.bin: u-boot FORCE
	$(call if_changed,objcopy)

OBJCOPYFLAGS_u-boot-x86-reset16.bin := -O binary -j .resetvec
u-boot-x86-reset16.bin: u-boot FORCE
1613
	$(call if_changed,objcopy)
1614

1615
endif # CONFIG_X86
1616

1617 1618 1619 1620
OBJCOPYFLAGS_u-boot-app.efi := $(OBJCOPYFLAGS_EFI)
u-boot-app.efi: u-boot FORCE
	$(call if_changed,zobjcopy)

1621
u-boot.bin.o: u-boot.bin FORCE
1622 1623 1624 1625 1626 1627 1628 1629
	$(call if_changed,efipayload)

u-boot-payload.lds: $(LDSCRIPT_EFI) FORCE
	$(call if_changed_dep,cpp_lds)

# Rule to link the EFI payload which contains a stub and a U-Boot binary
quiet_cmd_u-boot_payload ?= LD      $@
      cmd_u-boot_payload ?= $(LD) $(LDFLAGS_EFI_PAYLOAD) -o $@ \
S
Simon Glass 已提交
1630
      -T u-boot-payload.lds arch/x86/cpu/call32.o \
1631
      lib/efi/efi.o lib/efi/efi_stub.o u-boot.bin.o \
1632
      $(addprefix arch/$(ARCH)/lib/,$(EFISTUB))
1633

1634
u-boot-payload: u-boot.bin.o u-boot-payload.lds FORCE
1635 1636 1637 1638 1639 1640
	$(call if_changed,u-boot_payload)

OBJCOPYFLAGS_u-boot-payload.efi := $(OBJCOPYFLAGS_EFI)
u-boot-payload.efi: u-boot-payload FORCE
	$(call if_changed,zobjcopy)

1641 1642
u-boot-img.bin: spl/u-boot-spl.bin u-boot.img FORCE
	$(call if_changed,cat)
1643

1644 1645 1646 1647
#Add a target to create boot binary having SPL binary in PBI format
#concatenated with u-boot binary. It is need by PowerPC SoC having
#internal SRAM <= 512KB.
MKIMAGEFLAGS_u-boot-spl.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1648 1649
		-R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage \
		-A $(ARCH) -a $(CONFIG_SPL_TEXT_BASE)
1650 1651 1652 1653

spl/u-boot-spl.pbl: spl/u-boot-spl.bin FORCE
	$(call if_changed,mkimage)

1654 1655 1656
ifeq ($(ARCH),arm)
UBOOT_BINLOAD := u-boot.img
else
1657 1658 1659
ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
UBOOT_BINLOAD := u-boot-with-dtb.bin
else
1660 1661
UBOOT_BINLOAD := u-boot.bin
endif
1662
endif
1663

1664 1665 1666
OBJCOPYFLAGS_u-boot-with-spl-pbl.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO) \
			  --gap-fill=0xff

1667
u-boot-with-spl-pbl.bin: spl/u-boot-spl.pbl $(UBOOT_BINLOAD) FORCE
1668 1669
	$(call if_changed,pad_cat)

1670 1671 1672 1673 1674
# PPC4xx needs the SPL at the end of the image, since the reset vector
# is located at 0xfffffffc. So we can't use the "u-boot-img.bin" target
# and need to introduce a new build target with the full blown U-Boot
# at the start padded up to the start of the SPL image. And then concat
# the SPL image to the end.
1675 1676 1677 1678 1679

OBJCOPYFLAGS_u-boot-img-spl-at-end.bin := -I binary -O binary \
	--pad-to=$(CONFIG_UBOOT_PAD_TO) --gap-fill=0xff
u-boot-img-spl-at-end.bin: u-boot.img spl/u-boot-spl.bin FORCE
	$(call if_changed,pad_cat)
1680

1681 1682
quiet_cmd_u-boot-elf ?= LD      $@
	cmd_u-boot-elf ?= $(LD) u-boot-elf.o -o $@ \
1683
	-T u-boot-elf.lds --defsym=$(CONFIG_PLATFORM_ELFENTRY)=$(CONFIG_SYS_TEXT_BASE) \
1684
	-Ttext=$(CONFIG_SYS_TEXT_BASE)
1685
u-boot.elf: u-boot.bin u-boot-elf.lds
1686 1687
	$(Q)$(OBJCOPY) -I binary $(PLATFORM_ELFFLAGS) $< u-boot-elf.o
	$(call if_changed,u-boot-elf)
1688

1689 1690 1691
u-boot-elf.lds: arch/u-boot-elf.lds prepare FORCE
	$(call if_changed_dep,cpp_lds)

1692 1693 1694 1695 1696 1697 1698 1699
# MediaTek's ARM-based u-boot needs a header to contains its load address
# which is parsed by the BootROM.
# If the SPL build is enabled, the header will be added to the spl binary,
# and the spl binary and the u-boot.img will be combined into one file.
# Otherwise the header will be added to the u-boot.bin directly.

ifeq ($(CONFIG_SPL),y)
spl/u-boot-spl-mtk.bin: spl/u-boot-spl
1700 1701 1702

u-boot-mtk.bin: u-boot-with-spl.bin
	$(call if_changed,copy)
1703 1704 1705 1706 1707 1708 1709 1710 1711
else
MKIMAGEFLAGS_u-boot-mtk.bin = -T mtk_image \
	-a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
	-n "$(patsubst "%",%,$(CONFIG_MTK_BROM_HEADER_INFO))"

u-boot-mtk.bin: u-boot.bin FORCE
	$(call if_changed,mkimage)
endif

1712 1713 1714 1715 1716 1717
quiet_cmd_endian_swap = SWAP    $@
      cmd_endian_swap = $(srctree)/tools/endian-swap.py $< $@

u-boot-swap.bin: u-boot.bin FORCE
	$(call if_changed,endian_swap)

1718 1719
ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(ARCH)/Makefile.postlink)

1720 1721 1722 1723 1724 1725 1726 1727
# Generate linker list symbols references to force compiler to not optimize
# them away when compiling with LTO
ifdef CONFIG_LTO
u-boot-keep-syms-lto := keep-syms-lto.o
u-boot-keep-syms-lto_c := $(patsubst %.o,%.c,$(u-boot-keep-syms-lto))

quiet_cmd_keep_syms_lto = KSL     $@
      cmd_keep_syms_lto = \
1728
	$(srctree)/scripts/gen_ll_addressable_symbols.sh $(NM) $^ > $@
1729 1730 1731 1732 1733 1734 1735 1736 1737 1738 1739 1740 1741

quiet_cmd_keep_syms_lto_cc = KSLCC   $@
      cmd_keep_syms_lto_cc = \
	$(CC) $(filter-out $(LTO_CFLAGS),$(c_flags)) -c -o $@ $<

$(u-boot-keep-syms-lto_c): $(u-boot-main)
	$(call if_changed,keep_syms_lto)
$(u-boot-keep-syms-lto): $(u-boot-keep-syms-lto_c)
	$(call if_changed,keep_syms_lto_cc)
else
u-boot-keep-syms-lto :=
endif

1742 1743
# Rule to link u-boot
# May be overridden by arch/$(ARCH)/config.mk
1744 1745
ifdef CONFIG_LTO
quiet_cmd_u-boot__ ?= LTO     $@
1746
      cmd_u-boot__ ?=								\
1747 1748 1749 1750 1751 1752 1753 1754 1755 1756 1757 1758
		$(CC) -nostdlib -nostartfiles					\
		$(LTO_FINAL_LDFLAGS) $(c_flags)					\
		$(KBUILD_LDFLAGS:%=-Wl,%) $(LDFLAGS_u-boot:%=-Wl,%) -o $@	\
		-T u-boot.lds $(u-boot-init)					\
		-Wl,--whole-archive						\
			$(u-boot-main)						\
			$(u-boot-keep-syms-lto)					\
			$(PLATFORM_LIBS)					\
		-Wl,--no-whole-archive						\
		-Wl,-Map,u-boot.map;						\
		$(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
else
1759
quiet_cmd_u-boot__ ?= LD      $@
1760 1761
      cmd_u-boot__ ?= $(LD) $(KBUILD_LDFLAGS) $(LDFLAGS_u-boot) -o $@		\
		-T u-boot.lds $(u-boot-init)					\
1762
		--whole-archive							\
1763
			$(u-boot-main)						\
1764
		--no-whole-archive						\
1765 1766
		$(PLATFORM_LIBS) -Map u-boot.map;				\
		$(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1767
endif
1768

1769 1770
quiet_cmd_smap = GEN     common/system_map.o
cmd_smap = \
1771 1772 1773 1774
	smap=`$(call SYSTEM_MAP,u-boot) | \
		awk '$$2 ~ /[tTwW]/ {printf $$1 $$3 "\\\\000"}'` ; \
	$(CC) $(c_flags) -DSYSTEM_MAP="\"$${smap}\"" \
		-c $(srctree)/common/system_map.c -o common/system_map.o
1775

1776
u-boot:	$(u-boot-init) $(u-boot-main) $(u-boot-keep-syms-lto) u-boot.lds FORCE
1777
	+$(call if_changed,u-boot__)
1778 1779
ifeq ($(CONFIG_KALLSYMS),y)
	$(call cmd,smap)
1780
	$(call cmd,u-boot__) common/system_map.o
1781
endif
W
wdenk 已提交
1782

R
Rick Chen 已提交
1783 1784 1785 1786
ifeq ($(CONFIG_RISCV),y)
	@tools/prelink-riscv $@ 0
endif

1787 1788 1789 1790 1791
quiet_cmd_sym ?= SYM     $@
      cmd_sym ?= $(OBJDUMP) -t $< > $@
u-boot.sym: u-boot FORCE
	$(call if_changed,sym)

M
Michal Simek 已提交
1792
# The actual objects are generated when descending,
1793 1794
# make sure no implicit rule kicks in
$(sort $(u-boot-init) $(u-boot-main)): $(u-boot-dirs) ;
1795

1796
# Handle descending into subdirectories listed in $(u-boot-dirs)
1797 1798 1799 1800
# Preset locale variables to speed up the build process. Limit locale
# tweaks to this spot to avoid wrong language settings when running
# make menuconfig etc.
# Error messages still appears in the original language
W
wdenk 已提交
1801

1802
PHONY += $(u-boot-dirs)
1803
$(u-boot-dirs): prepare scripts
1804 1805
	$(Q)$(MAKE) $(build)=$@

1806
tools: prepare
1807 1808 1809 1810 1811
# The "tools" are needed early
$(filter-out tools, $(u-boot-dirs)): tools
# The "examples" conditionally depend on U-Boot (say, when USE_PRIVATE_LIBGCC
# is "yes"), so compile examples after U-Boot is compiled.
examples: $(filter-out examples, $(u-boot-dirs))
1812

1813 1814 1815 1816 1817
define filechk_uboot.release
	echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
endef

# Store (new) UBOOTRELEASE string in include/config/uboot.release
M
Masahiro Yamada 已提交
1818
include/config/uboot.release: include/config/auto.conf FORCE
1819 1820 1821
	$(call filechk,uboot.release)


1822 1823 1824 1825 1826 1827 1828 1829 1830 1831 1832 1833
# Things we need to do before we recursively start building the kernel
# or the modules are listed in "prepare".
# A multi level approach is used. prepareN is processed before prepareN-1.
# archprepare is used in arch Makefiles and when processed asm symlink,
# version.h and scripts_basic is processed / created.

# Listed in dependency order
PHONY += prepare archprepare prepare0 prepare1 prepare2 prepare3

# prepare3 is used to check if we are building in a separate output directory,
# and if so do:
# 1) Check that make has not been executed in the kernel src $(srctree)
1834
prepare3: include/config/uboot.release
1835
ifneq ($(KBUILD_SRC),)
M
Masahiro Yamada 已提交
1836 1837
	@$(kecho) '  Using $(srctree) as source for U-Boot'
	$(Q)if [ -f $(srctree)/.config -o -d $(srctree)/include/config ]; then \
1838 1839 1840 1841
		echo >&2 "  $(srctree) is not clean, please run 'make mrproper'"; \
		echo >&2 "  in the '$(srctree)' directory.";\
		/bin/false; \
	fi;
1842
endif
W
wdenk 已提交
1843

1844
# prepare2 creates a makefile if using a separate output directory
1845
prepare2: prepare3 outputmakefile cfg
1846

1847
prepare1: prepare2 $(version_h) $(timestamp_h) $(dt_h) \
M
Masahiro Yamada 已提交
1848
                   include/config/auto.conf
1849 1850 1851 1852
ifeq ($(wildcard $(LDSCRIPT)),)
	@echo >&2 "  Could not find linker script."
	@/bin/false
endif
1853

1854 1855
ifeq ($(CONFIG_USE_DEFAULT_ENV_FILE),y)
prepare1: $(defaultenv_h)
1856 1857

envtools: $(defaultenv_h)
1858 1859
endif

1860 1861
archprepare: prepare1 scripts_basic

1862 1863
prepare0: archprepare FORCE
	$(Q)$(MAKE) $(build)=.
W
wdenk 已提交
1864

1865 1866
# All the preparing..
prepare: prepare0
W
wdenk 已提交
1867

1868 1869 1870
# Generate some files
# ---------------------------------------------------------------------------

S
Simon Glass 已提交
1871
# Use sed to remove leading zeros from PATCHLEVEL to avoid using octal numbers
1872 1873 1874
define filechk_version.h
	(echo \#define PLAIN_VERSION \"$(UBOOTRELEASE)\"; \
	echo \#define U_BOOT_VERSION \"U-Boot \" PLAIN_VERSION; \
S
Simon Glass 已提交
1875 1876 1877
	echo \#define U_BOOT_VERSION_NUM $(VERSION); \
	echo \#define U_BOOT_VERSION_NUM_PATCH $$(echo $(PATCHLEVEL) | \
		sed -e "s/^0*//"); \
1878 1879
	echo \#define CC_VERSION_STRING \"$$(LC_ALL=C $(CC) --version | head -n 1)\"; \
	echo \#define LD_VERSION_STRING \"$$(LC_ALL=C $(LD) --version | head -n 1)\"; )
1880 1881
endef

1882 1883 1884 1885
# The SOURCE_DATE_EPOCH mechanism requires a date that behaves like GNU date.
# The BSD date on the other hand behaves different and would produce errors
# with the misused '-d' switch.  Respect that and search a working date with
# well known pre- and suffixes for the GNU variant of date.
1886
define filechk_timestamp.h
1887 1888
	(if test -n "$${SOURCE_DATE_EPOCH}"; then \
		SOURCE_DATE="@$${SOURCE_DATE_EPOCH}"; \
1889 1890 1891 1892 1893 1894 1895 1896
		DATE=""; \
		for date in gdate date.gnu date; do \
			$${date} -u -d "$${SOURCE_DATE}" >/dev/null 2>&1 && DATE="$${date}"; \
		done; \
		if test -n "$${DATE}"; then \
			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_DATE "%b %d %C%y"'; \
			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TIME "%T"'; \
			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TZ "%z"'; \
1897
			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_EPOCH %s'; \
1898 1899 1900
		else \
			return 42; \
		fi; \
1901 1902 1903 1904
	else \
		LC_ALL=C date +'#define U_BOOT_DATE "%b %d %C%y"'; \
		LC_ALL=C date +'#define U_BOOT_TIME "%T"'; \
		LC_ALL=C date +'#define U_BOOT_TZ "%z"'; \
1905
		LC_ALL=C date +'#define U_BOOT_EPOCH %s'; \
1906
	fi)
1907 1908
endef

1909
define filechk_defaultenv.h
1910
	( { grep -v '^#' | grep -v '^$$' || true ; echo '' ; } | \
1911
	 tr '\n' '\0' | \
1912
	 sed -e 's/\\\x0\s*//g' | \
1913
	 xxd -i ; )
1914 1915
endef

1916 1917 1918 1919 1920 1921 1922 1923
define filechk_dt.h
	(if test -n "$${DEVICE_TREE}"; then \
		echo \#define DEVICE_TREE \"$(DEVICE_TREE)\"; \
	else \
		echo \#define DEVICE_TREE CONFIG_DEFAULT_DEVICE_TREE; \
	fi)
endef

1924
$(version_h): include/config/uboot.release FORCE
1925 1926 1927 1928 1929
	$(call filechk,version.h)

$(timestamp_h): $(srctree)/Makefile FORCE
	$(call filechk,timestamp.h)

1930 1931 1932
$(dt_h): $(srctree)/Makefile FORCE
	$(call filechk,dt.h)

1933 1934 1935
$(defaultenv_h): $(CONFIG_DEFAULT_ENV_FILE:"%"=%) FORCE
	$(call filechk,defaultenv.h)

1936 1937 1938 1939 1940 1941 1942 1943 1944 1945 1946 1947 1948 1949 1950 1951 1952 1953 1954 1955 1956 1957 1958 1959 1960
# ---------------------------------------------------------------------------
# Devicetree files

ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/boot/dts/),)
dtstree := arch/$(SRCARCH)/boot/dts
endif

ifneq ($(dtstree),)

%.dtb: prepare3 scripts_dtc
	$(Q)$(MAKE) $(build)=$(dtstree) $(dtstree)/$@

PHONY += dtbs dtbs_install
dtbs: prepare3 scripts_dtc
	$(Q)$(MAKE) $(build)=$(dtstree)

dtbs_install:
	$(Q)$(MAKE) $(dtbinst)=$(dtstree)

ifdef CONFIG_OF_EARLY_FLATTREE
all: dtbs
endif

endif

S
Simon Glass 已提交
1961
# Check dtc and pylibfdt, if DTC is provided, else build them
1962 1963
PHONY += scripts_dtc
scripts_dtc: scripts_basic
S
Simon Glass 已提交
1964 1965 1966 1967 1968 1969 1970 1971 1972 1973 1974 1975 1976 1977 1978 1979 1980 1981 1982 1983
	$(Q)if test "$(DTC)" = "$(DTC_INTREE)"; then \
		$(MAKE) $(build)=scripts/dtc; \
	else \
		if ! $(DTC) -v >/dev/null; then \
			echo '*** Failed to check dtc version: $(DTC)'; \
			false; \
		else \
			if test "$(call dtc-version)" -lt $(DTC_MIN_VERSION); then \
				echo '*** Your dtc is too old, please upgrade to dtc $(DTC_MIN_VERSION) or newer'; \
				false; \
			else \
				if [ -n "$(CONFIG_PYLIBFDT)" ]; then \
					if ! echo "import libfdt" | $(PYTHON3) 2>/dev/null; then \
						echo '*** pylibfdt does not seem to be available with $(PYTHON3)'; \
						false; \
					fi; \
				fi; \
			fi; \
		fi; \
	fi
1984

1985
# ---------------------------------------------------------------------------
1986
quiet_cmd_cpp_lds = LDS     $@
1987
cmd_cpp_lds = $(CPP) -Wp,-MD,$(depfile) $(cpp_flags) $(LDPPFLAGS) \
1988
		-D__ASSEMBLY__ -x assembler-with-cpp -std=c99 -P -o $@ $<
1989

1990
u-boot.lds: $(LDSCRIPT) prepare FORCE
1991
	$(call if_changed_dep,cpp_lds)
1992

1993 1994
spl/u-boot-spl.bin: spl/u-boot-spl
	@:
1995 1996
	$(SPL_SIZE_CHECK)

1997 1998 1999 2000 2001 2002
spl/u-boot-spl-dtb.bin: spl/u-boot-spl
	@:

spl/u-boot-spl-dtb.hex: spl/u-boot-spl
	@:

2003
spl/u-boot-spl: tools prepare \
2004 2005
		$(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb) \
		$(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_TPL_OF_PLATDATA),dts/dt.dtb)
2006
	$(Q)$(MAKE) obj=spl -f $(srctree)/scripts/Makefile.spl all
2007

2008 2009 2010
spl/sunxi-spl.bin: spl/u-boot-spl
	@:

2011 2012 2013
spl/sunxi-spl-with-ecc.bin: spl/sunxi-spl.bin
	@:

2014
spl/u-boot-spl.sfp: spl/u-boot-spl
2015 2016
	@:

2017 2018 2019
spl/boot.bin: spl/u-boot-spl
	@:

2020
tpl/u-boot-tpl.bin: tools prepare \
2021
		$(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb)
M
Masahiro Yamada 已提交
2022
	$(Q)$(MAKE) obj=tpl -f $(srctree)/scripts/Makefile.spl all
S
Simon Glass 已提交
2023
	$(TPL_SIZE_CHECK)
2024

2025
TAG_SUBDIRS := $(patsubst %,$(srctree)/%,$(u-boot-dirs) include)
2026

2027 2028 2029
FIND := find
FINDFLAGS := -L

2030
tags ctags:
2031
		ctags -w -o ctags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
L
Li Yang 已提交
2032
						-name '*.[chS]' -print`
2033
		ln -s ctags tags
W
wdenk 已提交
2034 2035

etags:
2036
		etags -a -o etags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
L
Li Yang 已提交
2037
						-name '*.[chS]' -print`
L
Li Yang 已提交
2038
cscope:
2039 2040
		$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) -name '*.[chS]' -print > \
						cscope.files
2041 2042 2043
		@find $(TAG_SUBDIRS) -name '*.[chS]' -type l -print | \
			grep -xvf - cscope.files > cscope.files.no-symlinks; \
		mv cscope.files.no-symlinks cscope.files
L
Li Yang 已提交
2044
		cscope -b -q -k
W
wdenk 已提交
2045

2046 2047
SYSTEM_MAP = \
		$(NM) $1 | \
W
wdenk 已提交
2048
		grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' | \
2049
		LC_ALL=C sort
2050
System.map:	u-boot
M
Masahiro Yamada 已提交
2051
		@$(call SYSTEM_MAP,$<) > $@
W
wdenk 已提交
2052 2053 2054

#########################################################################

2055 2056
# ARM relocations should all be R_ARM_RELATIVE (32-bit) or
# R_AARCH64_RELATIVE (64-bit).
2057
checkarmreloc: u-boot
2058 2059 2060 2061 2062 2063 2064
	@RELOC="`$(CROSS_COMPILE)readelf -r -W $< | cut -d ' ' -f 4 | \
		grep R_A | sort -u`"; \
	if test "$$RELOC" != "R_ARM_RELATIVE" -a \
		 "$$RELOC" != "R_AARCH64_RELATIVE"; then \
		echo "$< contains unexpected relocations: $$RELOC"; \
		false; \
	fi
2065

2066
tools/version.h: include/version.h
2067
	$(Q)mkdir -p $(dir $@)
2068 2069 2070
	$(call if_changed,copy)

envtools: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2071
	$(Q)$(MAKE) $(build)=tools/env
M
Mike Frysinger 已提交
2072

2073
tools-only: export TOOLS_ONLY=y
2074
tools-only: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2075 2076
	$(Q)$(MAKE) $(build)=tools

M
Masahiro Yamada 已提交
2077
tools-all: export HOST_TOOLS_ALL=y
2078
tools-all: envtools tools ;
M
Mike Frysinger 已提交
2079

2080 2081 2082
cross_tools: export CROSS_BUILD_TOOLS=y
cross_tools: tools ;

2083 2084
.PHONY : CHANGELOG
CHANGELOG:
2085 2086
	git log --no-merges U-Boot-1_1_5.. | \
	unexpand -a | sed -e 's/\s\s*$$//' > $@
2087

W
wdenk 已提交
2088 2089
#########################################################################

2090 2091 2092 2093 2094 2095 2096 2097
###
# Cleaning is done on three levels.
# make clean     Delete most generated files
#                Leave enough to build external modules
# make mrproper  Delete the current configuration, and all generated files
# make distclean Remove editor backup files, patch leftover files and the like

# Directories & files removed with 'make clean'
M
Masahiro Yamada 已提交
2098 2099
CLEAN_DIRS  += $(MODVERDIR) \
	       $(foreach d, spl tpl, $(patsubst %,$d/%, \
M
Masahiro Yamada 已提交
2100
			$(filter-out include, $(shell ls -1 $d 2>/dev/null))))
M
Masahiro Yamada 已提交
2101

2102
CLEAN_FILES += include/bmp_logo.h include/bmp_logo_data.h tools/version.h \
2103 2104
	       boot* u-boot* MLO* SPL System.map fit-dtb.blob* \
	       u-boot-ivt.img.log u-boot-dtb.imx.log SPL.log u-boot.imx.log \
2105
	       lpc32xx-* bl31.c bl31.elf bl31_*.bin image.map tispl.bin* \
2106
	       idbloader.img flash.bin flash.log defconfig keep-syms-lto.c
2107 2108

# Directories & files removed with 'make mrproper'
M
Masahiro Yamada 已提交
2109
MRPROPER_DIRS  += include/config include/generated spl tpl \
2110
		  .tmp_objdiff doc/output include/asm
2111 2112

# Remove include/asm symlink created by U-Boot before v2014.01
M
Masahiro Yamada 已提交
2113
MRPROPER_FILES += .config .config.old include/autoconf.mk* include/config.h \
2114
		  ctags etags tags TAGS cscope* GPATH GTAGS GRTAGS GSYMS \
2115
		  drivers/video/fonts/*.S include/asm
2116 2117 2118 2119 2120 2121

# clean - Delete most, but leave enough to build external modules
#
clean: rm-dirs  := $(CLEAN_DIRS)
clean: rm-files := $(CLEAN_FILES)

2122
clean-dirs	:= $(foreach f,$(u-boot-alldirs),$(if $(wildcard $(srctree)/$f/Makefile),$f))
2123

T
Tom Rini 已提交
2124
clean-dirs      := $(addprefix _clean_, $(clean-dirs))
2125 2126 2127 2128 2129 2130 2131 2132 2133 2134

PHONY += $(clean-dirs) clean archclean
$(clean-dirs):
	$(Q)$(MAKE) $(clean)=$(patsubst _clean_%,%,$@)

clean: $(clean-dirs)
	$(call cmd,rmdirs)
	$(call cmd,rmfiles)
	@find $(if $(KBUILD_EXTMOD), $(KBUILD_EXTMOD), .) $(RCS_FIND_IGNORE) \
		\( -name '*.[oas]' -o -name '*.ko' -o -name '.*.cmd' \
2135
		-o -name '*.ko.*' -o -name '*.su' -o -name '*.pyc' \
2136
		-o -name '.*.d' -o -name '.*.tmp' -o -name '*.mod.c' \
2137
		-o -name '*.lex.c' -o -name '*.tab.[ch]' \
2138
		-o -name '*.asn1.[ch]' \
2139 2140
		-o -name '*.symtypes' -o -name 'modules.order' \
		-o -name modules.builtin -o -name '.tmp_*.o.*' \
2141
		-o -name 'dsdt.aml' -o -name 'dsdt.asl.tmp' -o -name 'dsdt.c' \
2142
		-o -name '*.efi' -o -name '*.gcno' -o -name '*.so' \) \
2143
		-type f -print | xargs rm -f
2144 2145 2146 2147 2148 2149

# mrproper - Delete all generated files, including .config
#
mrproper: rm-dirs  := $(wildcard $(MRPROPER_DIRS))
mrproper: rm-files := $(wildcard $(MRPROPER_FILES))
mrproper-dirs      := $(addprefix _mrproper_,scripts)
W
wdenk 已提交
2150

2151 2152 2153 2154
PHONY += $(mrproper-dirs) mrproper archmrproper
$(mrproper-dirs):
	$(Q)$(MAKE) $(clean)=$(patsubst _mrproper_%,%,$@)

M
Masahiro Yamada 已提交
2155
mrproper: clean $(mrproper-dirs)
2156 2157
	$(call cmd,rmdirs)
	$(call cmd,rmfiles)
2158
	@rm -f arch/*/include/asm/arch
2159 2160 2161 2162

# distclean
#
PHONY += distclean
2163 2164

distclean: mrproper
2165 2166 2167
	@find $(srctree) $(RCS_FIND_IGNORE) \
		\( -name '*.orig' -o -name '*.rej' -o -name '*~' \
		-o -name '*.bak' -o -name '#*#' -o -name '.*.orig' \
2168 2169
		-o -name '.*.rej' -o -name '*%' -o -name 'core' \
		-o -name '*.pyc' \) \
2170
		-type f -print | xargs rm -f
2171
	@rm -f boards.cfg CHANGELOG
W
wdenk 已提交
2172 2173

backup:
2174
	F=`basename $(srctree)` ; cd .. ; \
2175
	gtar --force-local -zcvf `LC_ALL=C date "+$$F-%Y-%m-%d-%T.tar.gz"` $$F
W
wdenk 已提交
2176

2177 2178
help:
	@echo  'Cleaning targets:'
M
Masahiro Yamada 已提交
2179
	@echo  '  clean		  - Remove most generated files but keep the config'
2180 2181 2182
	@echo  '  mrproper	  - Remove all generated files + config + various backup files'
	@echo  '  distclean	  - mrproper + remove editor backup and patch files'
	@echo  ''
M
Masahiro Yamada 已提交
2183 2184 2185
	@echo  'Configuration targets:'
	@$(MAKE) -f $(srctree)/scripts/kconfig/Makefile help
	@echo  ''
2186 2187 2188
	@echo  'Test targets:'
	@echo  ''
	@echo  '  check           - Run all automated tests that use sandbox'
2189
	@echo  '  qcheck          - Run quick automated tests that use sandbox'
2190
	@echo  '  tcheck          - Run quick automated tests on tools'
2191
	@echo  ''
2192 2193
	@echo  'Other generic targets:'
	@echo  '  all		  - Build all necessary images depending on configuration'
2194
	@echo  '  tests		  - Build U-Boot for sandbox and run tests'
2195
	@echo  '* u-boot	  - Build the bare u-boot'
2196 2197 2198 2199
	@echo  '  dir/            - Build all files in dir and below'
	@echo  '  dir/file.[oisS] - Build specified target only'
	@echo  '  dir/file.lst    - Build specified mixed source/assembly target only'
	@echo  '                    (requires a recent binutils and recent build (System.map))'
2200 2201
	@echo  '  tags/ctags	  - Generate ctags file for editors'
	@echo  '  etags		  - Generate etags file for editors'
2202
	@echo  '  cscope	  - Generate cscope index'
2203 2204
	@echo  '  ubootrelease	  - Output the release version string (use with make -s)'
	@echo  '  ubootversion	  - Output the version stored in Makefile (use with make -s)'
2205
	@echo  "  cfg		  - Don't build, just create the .cfg files"
2206
	@echo  "  envtools	  - Build only the target-side environment tools"
2207 2208 2209
	@echo  ''
	@echo  'Static analysers'
	@echo  '  checkstack      - Generate a list of stack hogs'
2210
	@echo  '  coccicheck      - Execute static code analysis with Coccinelle'
2211 2212
	@echo  ''
	@echo  'Documentation targets:'
2213
	@$(MAKE) -f $(srctree)/doc/Makefile dochelp
2214 2215 2216 2217 2218 2219 2220 2221 2222 2223 2224 2225 2226 2227 2228 2229
	@echo  ''
	@echo  '  make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
	@echo  '  make V=2   [targets] 2 => give reason for rebuild of target'
	@echo  '  make O=dir [targets] Locate all output files in "dir", including .config'
	@echo  '  make C=1   [targets] Check all c source with $$CHECK (sparse by default)'
	@echo  '  make C=2   [targets] Force check of all c source with $$CHECK'
	@echo  '  make RECORDMCOUNT_WARN=1 [targets] Warn about ignored mcount sections'
	@echo  '  make W=n   [targets] Enable extra gcc checks, n=1,2,3 where'
	@echo  '		1: warnings which may be relevant and do not occur too often'
	@echo  '		2: warnings which occur quite often but may still be relevant'
	@echo  '		3: more obscure warnings, can most likely be ignored'
	@echo  '		Multiple levels can be combined with W=12 or W=123'
	@echo  ''
	@echo  'Execute "make" or "make all" to build all targets marked with [*] '
	@echo  'For further info see the ./README file'

2230
tests check:
2231
	$(srctree)/test/run
2232

2233 2234 2235
qcheck:
	$(srctree)/test/run quick

2236 2237 2238
tcheck:
	$(srctree)/test/run tools

2239 2240
# Documentation targets
# ---------------------------------------------------------------------------
2241 2242 2243 2244
DOC_TARGETS := xmldocs latexdocs pdfdocs htmldocs epubdocs cleandocs \
	       linkcheckdocs dochelp refcheckdocs
PHONY += $(DOC_TARGETS)
$(DOC_TARGETS): scripts_basic FORCE
2245
	$(Q)$(MAKE) $(build)=doc $@
2246

2247 2248 2249 2250 2251 2252 2253 2254 2255 2256 2257 2258
PHONY += checkstack ubootrelease ubootversion

checkstack:
	$(OBJDUMP) -d u-boot $$(find . -name u-boot-spl) | \
	$(PERL) $(src)/scripts/checkstack.pl $(ARCH)

ubootrelease:
	@echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"

ubootversion:
	@echo $(UBOOTVERSION)

2259 2260 2261 2262 2263 2264 2265 2266 2267 2268 2269 2270 2271 2272 2273 2274 2275 2276 2277 2278 2279 2280 2281 2282 2283 2284 2285 2286 2287 2288 2289 2290 2291 2292 2293 2294 2295 2296 2297 2298 2299 2300 2301 2302 2303 2304 2305 2306 2307
# Single targets
# ---------------------------------------------------------------------------
# Single targets are compatible with:
# - build with mixed source and output
# - build with separate output dir 'make O=...'
# - external modules
#
#  target-dir => where to store outputfile
#  build-dir  => directory in kernel source tree to use

ifeq ($(KBUILD_EXTMOD),)
        build-dir  = $(patsubst %/,%,$(dir $@))
        target-dir = $(dir $@)
else
        zap-slash=$(filter-out .,$(patsubst %/,%,$(dir $@)))
        build-dir  = $(KBUILD_EXTMOD)$(if $(zap-slash),/$(zap-slash))
        target-dir = $(if $(KBUILD_EXTMOD),$(dir $<),$(dir $@))
endif

%.s: %.c prepare scripts FORCE
	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
%.i: %.c prepare scripts FORCE
	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
%.o: %.c prepare scripts FORCE
	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
%.lst: %.c prepare scripts FORCE
	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
%.s: %.S prepare scripts FORCE
	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
%.o: %.S prepare scripts FORCE
	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
%.symtypes: %.c prepare scripts FORCE
	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)

# Modules
/: prepare scripts FORCE
	$(cmd_crmodverdir)
	$(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
	$(build)=$(build-dir)
%/: prepare scripts FORCE
	$(cmd_crmodverdir)
	$(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
	$(build)=$(build-dir)
%.ko: prepare scripts FORCE
	$(cmd_crmodverdir)
	$(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1)   \
	$(build)=$(build-dir) $(@:.ko=.o)
	$(Q)$(MAKE) -f $(srctree)/scripts/Makefile.modpost

2308
quiet_cmd_genenv = GENENV  $@
2309 2310 2311 2312 2313 2314
cmd_genenv = $(OBJCOPY) --dump-section .rodata.default_environment=$@ env/common.o; \
	sed --in-place -e 's/\x00/\x0A/g' $@

u-boot-initial-env: u-boot.bin
	$(call if_changed,genenv)

2315 2316 2317 2318 2319 2320 2321 2322
# Consistency checks
# ---------------------------------------------------------------------------

PHONY += coccicheck

coccicheck:
	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/$@

M
Michal Simek 已提交
2323
# FIXME Should go into a make.lib or something
2324 2325
# ===========================================================================

2326 2327 2328 2329 2330 2331
quiet_cmd_rmdirs = $(if $(wildcard $(rm-dirs)),CLEAN   $(wildcard $(rm-dirs)))
      cmd_rmdirs = rm -rf $(rm-dirs)

quiet_cmd_rmfiles = $(if $(wildcard $(rm-files)),CLEAN   $(wildcard $(rm-files)))
      cmd_rmfiles = rm -f $(rm-files)

2332 2333
# read all saved command lines

2334
cmd_files := $(wildcard .*.cmd)
2335 2336 2337 2338 2339 2340

ifneq ($(cmd_files),)
  $(cmd_files): ;	# Do not try to update included dependency files
  include $(cmd_files)
endif

2341 2342
endif    #ifeq ($(config-targets),1)
endif    #ifeq ($(mixed-targets),1)
2343 2344 2345 2346 2347
endif	# skip-makefile

PHONY += FORCE
FORCE:

2348
# Declare the contents of the PHONY variable as phony.  We keep that
2349 2350
# information in a variable so we can use it in if_changed and friends.
.PHONY: $(PHONY)